#!/usr/bin/python
# -*- coding: utf-8 -*-
## \namespace server

import subprocess
import time
import sys
import os
import random
import logging

from hga.controlgrupos.common.settings import LOGGING_CONFIG_FILE

from hga.controlgrupos.common.netdev import NetDev

from hga.controlgrupos.servidor.settingsservidor import SHARED_DIR
from hga.controlgrupos.common.settings import SHARED_COMP
from hga.controlgrupos.common.settings import SHARED_SUB

##\class SSharedDir
# \brief Creates shared dir resource
class SSharedDir:
    ##\fn __init__(self, groupname)
    # \brief Initialization webdav parameters
    # \param[in] groupname: Group name
    def __init__(self, groupname):
        logging.config.fileConfig(LOGGING_CONFIG_FILE)
        self.log = logging.getLogger('hgr.server')
        self.dir = SHARED_DIR
        self.activa = 0
        try:
            self.IP = '%s' % NetDev().default_ip()
        except:
            self.log.error("Error al obtener IP por defecto!")
        self.port = '8008'
        self.user = ''.join(random.sample('ABCDEFGHIJKLMNOPQRSTUVWXYZ', 8))
        self.password = ''.join(random.sample('ABCDEFGHIJKLMNOPQRSTUVWXYZ', 8))
        self.group = groupname
        self.SHARED_PRIVATE_DIR = os.path.join(SHARED_DIR, self.group)
        self.SHARED_PROFE = os.path.join(self.SHARED_PRIVATE_DIR, SHARED_SUB)
        self.SHARED_ALUM = os.path.join(self.SHARED_PRIVATE_DIR, SHARED_COMP)

        self.create_dirs()

    ##\fn start(self)
    # \brief Start webdav serrver
    def start(self):
        self.popen(['davserver', '-D', self.dir, '-H', self.IP, '-P', self.port, '-u', self.user, '-p', self.password, '-d' ,'start'])
        self.activa = 1


    ##\fn stop(self)
    # \brief Stop webdav server
    def stop(self):
        self.popen(['davserver', '-D', self.dir, '-H', self.IP, '-P', self.port, '-u', self.user, '-p', self.password, '-d' ,'stop'])
        self.activa = 0

    ##\fn create_dirs(self)
    # \brief Initialization of shared directories
    def create_dirs(self):
        if os.access(self.dir, os.F_OK) == False:
            os.mkdir(self.dir, 0755)
        
        if os.access(os.path.join(SHARED_DIR, self.group), os.F_OK) == False:
            os.mkdir(os.path.join(SHARED_DIR, self.group), 0755)

        if os.access(os.path.join(self.SHARED_PROFE), os.F_OK) == False:
            os.mkdir(os.path.join(self.SHARED_PROFE), 0755)

        if os.access(os.path.join(self.SHARED_ALUM), os.F_OK) == False:
            os.mkdir(os.path.join(self.SHARED_ALUM), 0755)

                
    ##\fn popen(self, cmd)
    # \brief Aux method for executing system command
    # \param[in] cmd: system command and options
    def popen(self, cmd):
        process = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=sys.stderr, stdin=subprocess.PIPE)
        res = process.communicate()
        return process, res
