#!/usr/bin/env python
# -*- coding: utf-8 -*-
import sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from hga.controldesktop.controldesktop import ControlDesktop

class GestionControlDesktop:
	def __init__(self, core, acceso_desktop):
		self.core = core
		self.acceso_desktop = acceso_desktop

	def gui_handlers_controldesktop(self):
		#Diccionario con los manejadores de las peticiones del GUI
		self.gui_handlers = {
			"SOL_CONTROL_REMOTO": self.sol_control_remoto,
			"SOL_ACCESO_REMOTO": self.sol_acceso_remoto,
			"SOL_EMISION_ALUGRUPO": self.sol_emision_alugrupo,
			"STOP_EMISION_ALUGRUPO": self.stop_emision_alugrupo, 
			"DEMO_GRUPO": self.realizar_demostracion_grupo,
			"DEMO_USER": self.realizar_demostracion_usuario,
			"STOP_DEMO":self.stop_demo,
			"APAGAR_EQUIPO": self.apagar_equipo,
			"BLOQUEAR_PANTALLA": self.bloquear_pantalla,
			"DESBLOQUEAR_PANTALLA": self.desbloquear_pantalla,
			"REINICIAR_EQUIPO": self.reiniciar_equipo,
			"EJECUTAR_APLICACION": self.ejecutar_aplicacion,
			"EJECUTAR_NAVEGADOR": self.ejecutar_navegador,
			"BLOQUEAR_INTERNET": self.bloquear_internet,
			"DESBLOQUEAR_INTERNET": self.desbloquear_internet,
			"ABRIR_OPEN_OFFICE": self.abrir_open_office,
			"MENSAJE_INFO": self.enviar_mensaje_info,
			"ESCRITORIO_ALUMNO": self.escritorio_alumno,
		}
		return self.gui_handlers

	def apagar_equipo(self, nick=None):
		self.acceso_desktop.apagar_equipo_remoto(self.core, nick)
	
	def bloquear_pantalla(self, nick=None):
		self.acceso_desktop.bloquear_pantalla_remota(self.core, nick)

	def desbloquear_pantalla(self, nick=None):
		self.acceso_desktop.desbloquear_pantalla_remota(self.core, nick)

	def reiniciar_equipo(self, nick=None):
		self.acceso_desktop.reiniciar_equipo_remoto(self.core, nick)

	def ejecutar_aplicacion(self, app, nick=None):
		self.acceso_desktop.buscar_aplicacion(self.core, app, nick)

	def ejecutar_navegador(self, url, nick=None):
		self.acceso_desktop.ejecutar_navegador(self.core, url, nick)

	def bloquear_internet(self, nick=None):
		self.acceso_desktop.bloquear_internet(self.core, nick)

	def desbloquear_internet(self, nick=None):
		self.acceso_desktop.desbloquear_internet(self.core, nick)

	def abrir_open_office(self, nick=None):
		self.acceso_desktop.abrir_open_office(self.core, nick)

	def enviar_mensaje_info(self, msg, nick=None):
		self.acceso_desktop.enviar_mensaje_info(self.core, msg, nick)

	def sol_acceso_remoto(self, nick):
		self.acceso_desktop.solicitar_acceso_remoto(nick,self.core,"VISUALIZAR")

	def sol_control_remoto(self, nick):
		self.acceso_desktop.solicitar_acceso_remoto(nick,self.core,"CONTROL")

	def sol_emision_alugrupo(self, nick):
		self.acceso_desktop.solicitar_emision_alumno_grupo(nick,self.core,"EMISION_ALUGRUPO")

	def stop_emision_alugrupo(self, nick):
		self.acceso_desktop.stop_emision_alumno_grupo(nick,self.core)

	def realizar_demostracion_usuario(self, nick):
		self.acceso_desktop.demostracion_usuario(nick, self.core,"DEMO_USER")

	def realizar_demostracion_grupo(self):
		self.acceso_desktop.demostracion_grupo(self.core,"DEMO_GRUPO")

	def stop_demo(self, nick=None):
		self.acceso_desktop.stop_demostracion(self.core, nick)

	def escritorio_alumno(self, nick):
		self.acceso_desktop.escritorio_alumno(self.core, nick)