#!/usr/bin/python
# -*- encoding: utf-8 -*-
## \namespace gui_controldesktop
from PyQt4 import QtCore, QtGui
import commands
import thread

from hga.controldesktop.gui_controldesktop.ui_ventana_ejecutar_app import ui_VentanaEjecutarAPP


class VentanaEjecutarAPP(QtGui.QDialog, ui_VentanaEjecutarAPP):
	def __init__(self, gestion, users=None, parent=None):
		super(VentanaEjecutarAPP, self).__init__(parent)
		self.gestion=gestion
		self.users=users
		self.setupUi(self)
		self.center()
		self.files=None
		
		self.buscar.textChanged.connect(self.ejecutar_busqueda)
		self.connect(self.listWidget, QtCore.SIGNAL('itemClicked(QListWidgetItem *)'), self.selecciona_app)
		self.connect(self.btnAceptar, QtCore.SIGNAL("clicked()"), self.ejecutar_app)
		self.connect(self.btnCancelar, QtCore.SIGNAL("clicked()"), self.closeEvent)
		self.connect(self, QtCore.SIGNAL('triggered()'), self.closeEvent)
		
		self.btnAceptar.setEnabled(False)

	def selecciona_app(self, item):
		self.buscar.setText(item.text())
		self.btnAceptar.setEnabled(True)

	def ejecutar_app(self):
		app = str(self.buscar.text())
		if len(app.strip(' ')) > 0:
			self.close()
			if not self.users: 
				self.gestion.controldesktop_handlers["EJECUTAR_APLICACION"](app)
			else:
				app=[app]
				map(self.gestion.controldesktop_handlers["EJECUTAR_APLICACION"],app, self.users)

	def ejecutar_busqueda(self):
		self.btnAceptar.setEnabled(False)
		self.listWidget.clear()
		if self.buscar.text():
			consulta="grep -nisI "'^Name='" /usr/share/applications/*.desktop | cut -d ""="" -f 2 | grep -i '%s'" % self.buscar.text()
			consulta = str(consulta)
			self.ejecutar_comando(consulta)
			if self.files != None:
				for item in self.files:
					self.listWidget.addItem(item)

	def ejecutar_comando(self, consulta):
		files = commands.getoutput(consulta)
		self.files = files.split("\n")

	def closeEvent(self,event=None):
		self.close()

	def center(self):
		GeoFrame = self.frameGeometry()
		center = QtGui.QDesktopWidget().availableGeometry().center()
		GeoFrame.moveCenter(center)
		self.move(GeoFrame.topLeft())