#!/usr/bin/python
# -*- encoding: utf-8 -*-
## \namespace gui_controldesktop
from PyQt4 import QtCore, QtGui

from hga.controldesktop.gui_controldesktop.ui_lockgrupo import ui_LockGrupo
import hga.gui.common.icon_rc

class VentanaLockGrupo(QtGui.QDialog, ui_LockGrupo):
	def __init__(self, controldesktop, users, parent=None):
		super(VentanaLockGrupo, self).__init__(parent)
		self.setupUi(self)
		self.center()
		self.controldesktop = controldesktop
		self.usuarios = users
		
		self.lockedIcon = QtGui.QIcon()
		self.lockedIcon.addPixmap(QtGui.QPixmap(":/img/icon/locked59"))
		self.unLockedIcon = QtGui.QIcon()
		self.unLockedIcon.addPixmap(QtGui.QPixmap(":/img/icon/security81"))

		self.connect(self, QtCore.SIGNAL('triggered()'), self.closeEvent)
		self.connect(self.btnBloquear, QtCore.SIGNAL("clicked()"), self.bloquear)
		self.connect(self.btnDesbloquear, QtCore.SIGNAL("clicked()"), self.desbloquear)
		self.connect(self, QtCore.SIGNAL("generarLista"), self.generar_lista_bloqueados)

		self.generar_lista_bloqueados(self.usuarios)
		self.controldesktop.gui.btnBloquear.setEnabled(False)

	#Crea la lista de usuarios
	def generar_lista_bloqueados(self, users):
		self.users = users

		self.usuarios = dict( [(u, self.users[u]) for u in self.users if not self.users[u]["banned"] ])
		
		self.listWidget.clear()
		for nick in self.usuarios.keys():
			user = self.usuarios.get(nick)
			item = QtGui.QListWidgetItem(user.get('nick'))
			if user.get('nick') in self.controldesktop.lockList and self.controldesktop.lockList[nick] == True:
				item.setIcon(self.lockedIcon)
			else:
				item.setIcon(self.unLockedIcon)
			self.listWidget.addItem(item)

	def bloquear(self):
		self.controldesktop.gui.controldesktop_handlers["BLOQUEAR_PANTALLA"]()
		for nick in self.usuarios:
				self.controldesktop.lockList[nick]=True
		self.closeEvent()

	def desbloquear(self):
		self.controldesktop.gui.controldesktop_handlers["DESBLOQUEAR_PANTALLA"]()
		for nick in self.usuarios:
				self.controldesktop.lockList[nick]=False
		self.closeEvent()

	def closeEvent(self,event=None):
		self.close()
		self.controldesktop.gui.btnBloquear.setEnabled(True)
		self.controldesktop.gui.btnBloquear.setChecked(False)
		self.controldesktop.subclase = None

	def center(self):
		GeoFrame = self.frameGeometry()
		center = QtGui.QDesktopWidget().availableGeometry().center()
		GeoFrame.moveCenter(center)
		self.move(GeoFrame.topLeft())
