# -*- coding: utf-8 -*-
## \namespace controldesktop
import os
import string
from random import choice

# Directorio donde se guardará la contraseña aleatoria generada.
PASS_DIR="/tmp/.x11vnc_passwd"

# Se fuerza la finalización del proceso x11vnc
FINALIZAR_PRO_X11VNC="pkill -9 x11vnc"

# Se fuerza la finalización del proceso xvnc4viewer
FINALIZAR_PRO_XVNC4VIEWER="pkill -9 xvnc4viewer"

# Fichero para APAGAR/REINICIAR
SCRIPT_SHUTDOWN="/usr/bin/cga-hgr-controldesktop.sh"

# Fichero para el bloqueo de pantalla
SCRIPT_LOCKSCREEN="/usr/bin/cga-hgr-lockscreen"

# Fichero para bloquear internet al cliente
SCRIPT_BLOCKINTERNET="/usr/bin/cga-hgr-bloqueo-internet.sh"
SCRIPT_UNBLOCKINTERNET="/usr/bin/cga-hgr-desbloqueo-internet.sh"

LANZA_NAVEGADOR="firefox "

LANZA_OFFICE="libreoffice --writer"

# Claves necesarias correspondientes a las funcionalidades control remoto,
# visualización remota y demostración (individual o de grupo).
KEY_DEMOGRUPO = "DEMO_GRUPO"
KEY_DEMOALUM = "DEMO_ALUM"
KEY_ACCESO = "ACCESO"

# Genera una contraseña aleatoria
def genera_clave():
	clave = ''.join([choice(string.letters + string.digits) for i in range(8)])
	return clave

# Guarda la contraseña aleatoria generada codificandola para el servicio VNC
def guardar_clave(clave):
	os.system("x11vnc -storepasswd '"+clave+"' "+PASS_DIR+" > /dev/null 2>&1")

# Comando para consultar el servicio correspondiente al servidor VNC
def get_ConsultaDemo(ipServidor):
	consulta = "netstat -ptna 2>/dev/null | grep x11vnc | grep "+ipServidor+" | grep 'ESTABLECIDO' | awk '{print $7}' | cut -d ""/"" -f 1"
	return consulta

# Comando para consultar el servicio correspondiente al cliente VNC
def get_ConsultaAcceso(ipServidor):
	consulta = "netstat -ptna 2>/dev/null | grep "+ipServidor+":5905 | grep xvnc4viewer | grep 'ESTABLECIDO' | awk '{print $7}' | cut -d ""/"" -f 1"
	return consulta