#!/usr/bin/python
# -*- encoding: utf-8 -*-
## \namespace controleditor
import os
import threading
import commands
import logging

from PyQt4 import QtGui, QtCore
from hga.controlgrupos.common.user_info import get_ip
from hga.controlgrupos.common.settings import HOMEDIR
from hga.controlgrupos.common.exception import NoDefaultDevice

from hga.controlgrupos.common.settings import LOGGING_CONFIG_FILE

logging.config.fileConfig(LOGGING_CONFIG_FILE)
lerror = logging.error

import logging

# Clave de la funcionalidad.
KEY_DOC = "DOC"
# Comando para consultar el servicio.
CONSULTA = "netstat -pnta 2>/dev/null | grep '9001.*ESCUCHAR.*node' | awk '{print $7}' | cut -d ""/"" -f 1"
# Ruta del fichero a ejecutar para arrancar el servidor etherpad.
RUTA=os.path.join("/opt","etherpad-lite","bin","run.sh")
# Ruta del fichero que modifica el settings.json de etherpad antes de arrancar el servicio.
SCRIPT_ETHERPAD=os.path.join("/usr","bin","cga-hgr-edit_settings_etherpad.sh")

# Ruta del fichero que modifica el settings.json de etherpad antes de arrancar el servicio.
SCRIPT_ETHERPAD_PROPIETARIO=os.path.join("/usr","bin","cga-hgr-permisos.sh")

class ControlEditor_Server():
	def __init__(self):
		self.core = None
		self.pid = None
		self.url = None
		self.nomPad = None

	## \fn def controleditor_handlers(self):
	# \brief Definición de los handlers que se necesiten.
	def controleditor_handlers(self):
		self.CEServer_handlers = {
			"STATUS_SERVERHC": self.comprueba_estado_serverHC,
			"STOP_SERVERHC": self.stop_server,
		}
		return self.CEServer_handlers

	## \fn def enviar_mensaje_URL(self, core, nomPad):
	# \brief Función que genera la URL del documento (pad) que ha cargado el profesor y la envía al grupo de clientes mediante mensaje.
	# \param nomPad Nombre del documento (pad)
	def enviar_mensaje_URL(self, core, nomPad):
		self.nomPad = nomPad
		self.core = core
		if self.nomPad != None:
			self.setURL(self.nomPad)
			if self.url != None:
				msg = "START_EDITOR|"+self.url
				if bool(self.core.users):
					for user in self.core.users:
						nick = self.core.users[user].get("nick")
						self.core.sendmessage(nick,msg)
		else:
			self.core.enviar_gui_msg("No se ha indicado nombre para el documento","information")

	## \fn def comprueba_estado_serverHC(self, nick):
	# \brief Se ejecuta cuando lo solicita el cliente mediante mensaje.
	# \brief Comprueba el estado del servicio para devolverle el mensaje al cliente
	def comprueba_estado_serverHC(self, nick):
		if self.url == None:
			self.setURL(self.nomPad)
		if self.url != None and self.pid != None:
			msg = "START_EDITOR|"+self.url
			self.core.sendmessage(nick,msg)

	## \fn def stopServer_editor(self):
	# \brief Función que solicita la parada del servidor Etherpad
	def stopServer_editor(self):
		if self.core != None:
			self.stop_server()
			self.url = None
			self.nomPad = None
			self.core.gui.emit(QtCore.SIGNAL("serverStart"), False)
			for user in self.core.users:
				nick = self.core.users[user].get("nick")
				self.core.sendmessage(nick,"STOP_EDITOR")

	## \fn def setURL(self,nomPad):
	# \brief Modifica la URL del documento al que se va a acceder
	# \param nomPad Nombre del documento para añadirlo a la URL
	def setURL(self,nomPad):
		if nomPad != self.nomPad:
			self.nomPad = nomPad
		if self.nomPad != None:
			try:
				ipServidor = get_ip()
				self.url = "http://"+ipServidor+":9001/p/"+self.nomPad
			except NoDefaultDevice, e:
				lerror("Petición -> Abrir documento colaborativo. No hay conexión y no se pueden realizar algunas funciones necesarias: %s" % e)

	## \fn def start_server(self):
	# \brief Realiza el arranque del servidor
	def start_server(self, core):
		self.core = core
		if self.pid == None:
			# A la señal se le envia la key del proceso, "DOC" en el caso de etherpad y el comando requerido para dicho proceso
			self.core.start_progressBar(KEY_DOC,CONSULTA)
			os.popen('sudo '+str(SCRIPT_ETHERPAD_PROPIETARIO))
			os.spawnlp(os.P_NOWAIT, 'bash', 'bash', SCRIPT_ETHERPAD)
			pid = os.spawnlp(os.P_NOWAIT, 'sh', 'sh', RUTA)
			path = os.path.join(HOMEDIR,"Documentos")
			os.chdir(os.path.abspath(path))

	## \fn def stop_server(self):
	# \brief Realiza la parada del proceso del servidor
	def stop_server(self):
		if self.pid != None and self.pid != "":
			os.popen(str(SCRIPT_ETHERPAD)+' usuarioEtherpad')
			os.system('kill -9 '+str(self.pid))
			os.chdir(os.path.abspath("/usr/bin"))
			self.pid = None

	def set_pid(self, pid):
		self.pid = pid