#!/usr/bin/env python
# -*- coding: utf-8 -*-
import sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *



class GestionControlEditor:
	def __init__(self, core, CEServer):
		self.core = core
		self.CEServer = CEServer

	def gui_handlers_CEServer(self):
		#Diccionario con los manejadores de las peticiones del GUI
		self.gui_handlers_CEServer = {
			"ACT_SERVER_CONEDIT":self.control_editor,
			"MSG_ACCEDER_PAD": self.mensaje_acceder_pad,
			"PID_EDITOR": self.pid_editor,
		}
		return self.gui_handlers_CEServer

	## \fn def control_editor(self, accion):
	# \brief Solicita el arranque o la parada del servidor
	# \param nomPad Nombre del documento (pad)
	def control_editor(self, accion):
		if accion == "START":
			self.CEServer.start_server(self.core)
		elif accion == "STOP":
			self.CEServer.stopServer_editor()

	## \fn def mensaje_acceder_pad(self, nomPad=None):
	# \brief Solicita el envio del mensaje al cliente con la URL de acceso al documento
	# \param nomPad Nombre del documento (pad)
	def mensaje_acceder_pad(self, nomPad):
		self.CEServer.enviar_mensaje_URL(self.core, nomPad)

	def pid_editor(self, pid):
		self.CEServer.set_pid(pid)
