# -*- coding: utf-8 -*-
## \namespace common 
import os
import logging
import string

# \brief Config file for logging.
LOGGING_CONFIG_FILE="/etc/hgr/logging.conf"

AVAHI_SERVICE_TYPE = "_profe._tcp"
AVAHI_SERVICE_PORT = "8888"

# Caracteres válidos para los nombres de usuario y mucs
VALID_CHARS = string.ascii_letters + string.digits + "-" + "_" + " "

#File to write the PID in.
HGA_PID_FILE = "/tmp/hgr.pid"

SHARED_COMP="COMPARTIDA"

SHARED_SUB="SUBIDAS"

# \brief Command to execute by the identification method
IDENTIFY_COMMAND="/usr/bin/cga-hgr-identify-user"

#Definición rutas personales del usuario
HOMEDIR=os.path.expanduser("~")

HGRDIR=os.path.join(HOMEDIR, ".hgr")

DESKTOP_RUTA=os.path.join(HGRDIR, "desktop")

ROOM_RUTA=os.path.join(HGRDIR, "room")

ETHERPAD_RUTA=os.path.join(HGRDIR, "etherpad_bd")

def setup_hga_config_dir():
    # Comprueba y crea el directorio $HOME/.hgr
    try:
        os.stat(HGRDIR)
    except OSError:
        # El directorio no existe, se crea.
        os.mkdir(HGRDIR)
    try:
        os.stat(DESKTOP_RUTA)
    except OSError:
        # El directorio no existe, se crea.
        os.mkdir(DESKTOP_RUTA)
    try:
        os.stat(ROOM_RUTA)
    except OSError:
        # El directorio no existe, se crea.
        os.mkdir(ROOM_RUTA)
    try:
        os.stat(ETHERPAD_RUTA)
    except OSError:
        # El directorio no existe, se crea.
        os.mkdir(ETHERPAD_RUTA)  