# -*- coding: utf-8 -*-

##\namespace common
import sys
import commands
from pwd import getpwuid
from os import getuid

from subprocess import call as subcall
from PyQt4 import QtGui, QtCore

from hga.controlgrupos.common.netdev import NetDev
from hga.controlgrupos.common.settings import IDENTIFY_COMMAND

def get_hga_user_name():
    settings = QtCore.QSettings()
    nombre=settings.value("user/name", QtCore.QVariant(None)).toString()
    return nombre

## \fn get_user_name
# \brief Devuelve el nombre de usuario.
#\return string
def get_user_name():
    siguser = get_hga_user_name()
    nombre = unicode(siguser)
    return nombre

def get_ip():
    nd = NetDev()
    return nd.default_ip()

##\fn get_hostname
#\brief devuelve el FQDN
#\return string
def get_hostname():
    nd = NetDev()
    return nd.hostname()

##\fn generate_jid
#\brief devuelve el JID del usuario basandose en la MAc y en el FQDN.
#\return string
def generate_jid(hostname=None):
    nd = NetDev()
    mac = nd.default_mac()
    name = filter(lambda k: k !=':', mac)
    server = (hostname, nd.hostname())[hostname is None]
    return str("%s@%s/HGR" % (name, server))

def identify_user(username=None):
    if username == None:
        ret = subcall([IDENTIFY_COMMAND],)
    else:
        settings = QtCore.QSettings()
        settings.setValue("user/name", QtCore.QVariant(username))


##\fn def conexion_remoto(remote_ip):
#\brief Función para comprobar la conexión.
#\param remote_ip IP remota a la que se quiere realizar ping
#\return bool
def ping(ip):
    try:
        command = "ping -c1 "+ip+" | grep 'received' | awk '{print $4}'"
        ping = commands.getstatusoutput(command)
        if ping[0] == 0:
            if ping[1] == "1":
                return True
            else:
                return False
        else:
            return False
            print "Error al ejecutar el comando: %s - %s" % (ping[0],ping[1])
    except Exception, e:
         return False


if __name__=="__main__":
    u = get_user_name()
    print type(u)
    print u
    print generate_jid()
