# -*- coding: utf-8 -*-
import os

from PyQt4 import QtGui

## \namespace servidor

#\brief RPC methods to be called when a user joins the MUC
## Pay attention to the trailing ','. We don't want a single item's list
## to become a list of characters :)
RPC_ON_USER_CONNECT = ("IP","MAC")

GUI_SERVIDOR = "servidor"

LOG_SERVIDOR="hgr.server"

#\brief Directory containing .desktop files to load.
DESKTOP_APP_DIR = "/usr/share/hgr/desktop"

# \brief Icono para los .desktop con icono no-accesible
DEFAULT_APP_ICON = "/usr/share/hgr/default_app.png"

# \brief Teacher's RPC modules
# Indica dónde se encuentran los módulos que exportan llamadas RPC 
# del profesor.
RPC_MODULES="hga.rpc"

# \brief HGR's shared dir
# Directorio para los compartidos de HGR
SHARED_DIR=os.path.join(os.getenv("HOME"), "HGR")

# \brief Info about shares
# Información a mostrar cuando se inicia la compartición de archivos.
SHARED_INFO_TEXT=QtGui.QApplication.translate("SGuiProfe", "Se compartirán los archivos del directorio <b>%1</b>.<br>Los clientes subirán sus archivos al directorio <b>%2</b>.", None, QtGui.QApplication.UnicodeUTF8)

# \brief File in which to write our PID.
PID_FILE_SERVER="/tmp/hgr" + str(os.getuid()) + ".pid"

# \brief HTML help file
HGA_HTML_HELP_FILE="file:///usr/share/doc/hgr-doc/html/index.html"

# Puede ser requerido realizar la modificación de este comando según los procesos que ejecute ejabberd
CONSULTA_SERVER_COMMAND = "ps ax | grep ' S .*/usr/lib/erlang.*/var/lib/ejabberd' | grep -v grep | awk '{print $1}'"

KEY_SERVER = "START_SERVER_XMPP"
