#!/bin/env python
# -*- coding: UTF-8 -*-

import os
import time
import threading
import commands

##\class stream_Cliente
# \brief Clase del modulo controlStreaming para la recepcion de audios y videos
class stream_Cliente:

	## \fn stream_handlers_cliente(self)
	# \brief Handler del cliente de streaming.
	# \return self.stream_handlers, los handlers del cliente
	def stream_handlers_cliente(self):
		self.sc_handlers = {
			"RECIBIR_EMISION": self.recibir_emision,
			"KILL_VLC":self.kill_vlc,
		}
		return self.sc_handlers
	
	## \fn recibir_emision(self, ip_servidor)
	# \brief Se encarga de recibir la ip del servidor y lanzar la herramienta vlc para recibir el streaming.
	# \param ip_servidor, la ip donde estara a la escucha
	def recibir_emision(self, ip_servidor):
		#time.sleep(3)
		cadena = "vlc '--quiet' '--network-caching=5000' '-f' 'rtp://@%s:8080'" % ip_servidor
		thread = threading.Thread(target=self.ejecuta_streaming_cliente, args=(cadena,))
		thread.start()

	## \fn ejecuta_streaming_cliente(self, cadena)
	# \brief Ejecuta la sentencia pasada por el hilo para la recepcion del streaming.
	# \param cadena, la sentencia a ejecutar
	def ejecuta_streaming_cliente(self, cadena):
		os.system(str(cadena))

	## \fn kill_vlc(self)
	# \brief Cuando el servidor termina la emision lanza un mensaje para que el cliente mate el proceso.
	def kill_vlc(self):
		os.system('pkill -9 vlc')