# -*- coding: utf-8 -*-
##\namespace 
import sys

from PyQt4 import QtGui, QtCore

from hga.gui.servidor.gestion_streaming.ui_multimedia import Ui_WindowStreaming

##\class SGestion_streaming
# \brief Clase encargada de gestionar la ventana del modulo controlstreaming
class SGestion_streaming(QtGui.QMainWindow, Ui_WindowStreaming):

	## \fn __init__(self, SGestion, alumnoUnico=None)
	# \brief Inicia los valores de la clase.
	# \param SGestion, objeto de la clase sgestion para el manejo de los handlers y usuarios
	# \param alumnoUnico, diferencia si se ha seleccionado un usuario para la emision o es para el grupo completo 
	def __init__(self, SGestion, alumnoUnico=None):
		super(SGestion_streaming, self).__init__(None)
		self.setupUi(self)
		self.setupSignals()
		self.show()
		self.sgestion = SGestion
		self.fuenteStreaming = "file"
		self.alumnoUnico = alumnoUnico

	## \fn setupSignals(self)
	# \brief señales asociadas a la ventana.
	def setupSignals(self):
		self.connect(self.rbFile, QtCore.SIGNAL("clicked()"), self.streaming_file)
		self.connect(self.rbDVD, QtCore.SIGNAL("clicked()"), self.streaming_dvd)
		self.connect(self.rbCD, QtCore.SIGNAL("clicked()"), self.streaming_cd)
		self.connect(self.btnCancelar, QtCore.SIGNAL("clicked()"), self.salir)
		self.connect(self.btnAceptar, QtCore.SIGNAL("clicked()"), self.emitir_streaming)


	def salir(self):
		#self.sgestion.usuario_select_stream = None
		#self.sgestion.lista_usuarios_stream = False
		self.close()

	def streaming_file(self):
		self.fuenteStreaming = "file"

	def streaming_dvd(self):
		self.fuenteStreaming = "dvd"

	def streaming_cd(self):
		self.fuenteStreaming = "cd"

	## \fn emitir_streaming(self)
	# \brief Envia los parametros recogidos en la ventana al modulo controlstreaming.
	def emitir_streaming(self):
		self.close()
		fileStreaming = None
		
		if self.fuenteStreaming == "file":
			self.sgestion.ventanaDialog(4)
			result=self.sgestion.fname.exec_()
			if result == 1:
				fileStreaming = self.sgestion.fname.selectedFiles()[0]
		else:
			fileStreaming = self.sgestion.handlers["TRATAR_FUENTE"](self.fuenteStreaming)

		if fileStreaming != None:
			self.sgestion.handlers["EMITIR_STREAMING"](fileStreaming, self.alumnoUnico)