# -*- coding: utf-8 -*-
##\namespace

import sys

from PyQt4 import QtGui, QtCore

from hga.gui.servidor.gestion_tempcapturas.ui_tempcapturas import Ui_MainTempCap

##\class STemp_capturas
# \brief Clase encargada de gestionar el tiempo a transcurrir entre captura y captura seleccionado por el usuario
class STemp_capturas(QtGui.QMainWindow, Ui_MainTempCap):

	## \fn __init__(self, SGestion)
	# \brief Inicia los valores de la clase.
	# \param SGestion, objeto de la clase sgestion para el manejo de los handlers y usuarios
	def __init__(self, SGestion):
		super(STemp_capturas, self).__init__()
		self.setupUi(self)
		self.setupSignals()
		self.center()
		self.show()
		self.sgestion = SGestion
		self.cambio_delay = ""
		self.pintar_label_segundos()

	## \fn pintar_label_segundos(self)
	# \brief Pinta los segundos seleccionados en la etiqueta de la ventana (siempre que se haya seleccionado el por defecto).
	def pintar_label_segundos(self):
		if self.sgestion.delay_modificado != "":
			self.label_segundos.setText(str(self.sgestion.delay_modificado) + " segundos")
			self.horizontalSlider.setSliderPosition(self.sgestion.delay_modificado)

	## \fn setupSignals(self)
	# \brief señales asociadas a la ventana.
	def setupSignals(self):
		self.connect(self.horizontalSlider, QtCore.SIGNAL("valueChanged(int)"), self.cambia_valor)
		self.connect(self.btnCancel, QtCore.SIGNAL("clicked()"), self.cerrar)
		self.connect(self.btnAcep, QtCore.SIGNAL("clicked()"), self.aceptar)

	## \fn cambia_valor(self, value)
	# \brief Recoge el valor seleccionado por el usuario.
	# \param value, valor del horizontalSlider
	def cambia_valor(self, value):
		self.label_segundos.setText(str(value) + " segundos")
		self.sgestion.delay_modificado = value

	## \fn aceptar(self)
	# \brief Envia el valor seleccionado por el usuario al coreservidor.
	def aceptar(self):
		if self.sgestion.delay_modificado != "":
			self.sgestion.handlers["DELAY_CAPTURAS"](self.sgestion.delay_modificado)
		self.close()

	def cerrar(self):
		self.close()

	def center(self):
		screen = QtGui.QDesktopWidget().screenGeometry()
		size = self.geometry()
		self.move((screen.width()-size.width())/2, (screen.height()-size.height())/2)