# -*- coding: utf-8 -*-
##\namespace 
import sys
import os
import time
import ast
import logging
import logging.config
import commands
import shutil

from PyQt4 import QtGui, QtCore


from hga.controlgrupos.common.user_info import get_user_name
from hga.controlgrupos.common.user_info import identify_user
from hga.controlgrupos.common.settings import ROOM_RUTA
from hga.controlgrupos.common.settings import DESKTOP_RUTA
from hga.controlgrupos.common.settings import HOMEDIR
from hga.controlgrupos.common.settings import SHARED_SUB
from hga.controlgrupos.common.settings import VALID_CHARS
from hga.controlgrupos.common.settings import LOGGING_CONFIG_FILE
from hga.controldesktop.settings import KEY_DEMOGRUPO
from hga.controldesktop.settings import KEY_DEMOALUM
from hga.controleditor.controleditor_server import KEY_DOC
from hga.controlgrupos.common.exception import SInvalidGroupName

from hga.gui.servidor.ui_gestion import Ui_MainWindow
from hga.gui.servidor.sbaneados import SBaneados
from hga.gui.servidor.gestion_tempcapturas.stemp_capturas import STemp_capturas
from hga.controlcompartir.servidor.sshowinfo import SShowInfoAgain
from hga.gui.servidor.thread_sgestion import ProgressBar_thread
from hga.gui.servidor.gestion_streaming.sgestion_streaming import SGestion_streaming
from hga.controlstreaming.servidor.stream_server import FILTROS_STREAMING
from hga.controldesktop.gui_controldesktop.scontroldesktop import sControlDesktop
from hga.controleditor.gui_controleditor.scontroleditor_server import sControlEditor_server

import hga.gui.servidor.icon_rc
import hga.gui.common.icon_rc

from hga.controlgrupos.servidor.settingsservidor import DESKTOP_APP_DIR
from hga.controlgrupos.servidor.settingsservidor import SHARED_DIR
from hga.controlgrupos.servidor.settingsservidor import SHARED_INFO_TEXT
from hga.controlcompartir.servidor.shareddir import SSharedDir
   
logging.config.fileConfig(LOGGING_CONFIG_FILE)
linfo = logging.info
lerror = logging.error
ldebug = logging.debug

class SGestion(QtGui.QMainWindow, Ui_MainWindow):
	
	def __init__(self, parent=None):
		super(SGestion, self).__init__(parent)
		self.settings = QtCore.QSettings()
		self.setupUi(self)
		self.setupSignals()
		self.userSelected_panelControl = None
		self.gui_cDesktop = sControlDesktop(self)
		self.gui_cDesktop.controldesktop_signals()
		self.gui_cEditor = sControlEditor_server(self)
		self.procesos_progressBar = None
		self.procesoKey = ""
		self.gui_cEditor.controleditor_signals()
		self.good_users_conex = None
		self.banned_users_conex = None
		self.subclaseBaneados = None
		self.comboGrupos()
		self.grupoLocal = None
		self.sg_stream = None
		self.usuario_select_stream = None
		self.lista_usuarios_stream = False
		self.reset_gui = False
		self.fichaUsuario = False
		self.lista_user_help = dict()
		self.flagHelp = None
		self.nuevo_user = None

		#Prueba Delay
		self.delay_modificado = ""

		# Iconos de usuario
		self.icon = QtGui.QIcon()
		self.icon.addPixmap(QtGui.QPixmap(':/common/icon/social.png'))
		self.icon2 = QtGui.QIcon()
		self.icon2.addPixmap(QtGui.QPixmap(':/img/imagen.png'))

		# Definición de iconos: LEDS de conexión de los usuarios.
		self.icon38 = QtGui.QIcon()
		self.icon39 = QtGui.QIcon()
		self.icon38.addPixmap(QtGui.QPixmap(":/common/icon/icon1.png"))
		self.icon39.addPixmap(QtGui.QPixmap(":/common/icon/icon2.png"))

		#Icono cuando cambia el estado del boton cerrar grupo
		self.icon19 = QtGui.QIcon()
		self.icon19.addPixmap(QtGui.QPixmap(":/img/icon/unlocked44.png"))
		self.icon20 = QtGui.QIcon()
		self.icon20.addPixmap(QtGui.QPixmap(":/img/icon/security81.png"))

		#Iconos cuando cambia el estado del boton demostracion de grupos y de alumno
		self.icon31 = QtGui.QIcon()
		self.icon31.addPixmap(QtGui.QPixmap(":/img/icon/computer screen33.png"))		
		self.icon32 = QtGui.QIcon()
		self.icon32.addPixmap(QtGui.QPixmap(":/img/icon/stop22.png"))

		self.icon33 = QtGui.QIcon()
		self.icon33.addPixmap(QtGui.QPixmap(":/img/icon/computer screen33-2.png"))		
		self.icon34 = QtGui.QIcon()
		self.icon34.addPixmap(QtGui.QPixmap(":/img/icon/stop22-2.png"))

		#Iconos cuando cambia el estado del boton bloquear pantalla de grupos y de alumno
		self.icon40 = QtGui.QIcon()
		self.icon40.addPixmap(QtGui.QPixmap(":/img/icon/locked59.png"))		
		self.icon41 = QtGui.QIcon()
		self.icon41.addPixmap(QtGui.QPixmap(":/img/icon/security81.png"))

		self.icon42 = QtGui.QIcon()
		self.icon42.addPixmap(QtGui.QPixmap(":/img/icon/locked-32.png"))		
		self.icon43 = QtGui.QIcon()
		self.icon43.addPixmap(QtGui.QPixmap(":/img/icon/lock.png"))

		#icono de ayuda
		self.iconHelp = QtGui.QIcon()
		self.iconHelp.addPixmap(QtGui.QPixmap(":/common/icon/hombrecillo3.png"))

		#icono bloqueo navegacion internet Grandes
		self.iconBlockIntG = QtGui.QIcon()
		self.iconBlockIntG.addPixmap(QtGui.QPixmap(":/common/icon/bloque_internet_2.png"))
		self.iconDesblockIntG = QtGui.QIcon()
		self.iconDesblockIntG.addPixmap(QtGui.QPixmap(":/common/icon/desbloque_internet_2.png"))
		#icono bloqueo navegacion internet pequeños
		self.iconBlockInt = QtGui.QIcon()
		self.iconBlockInt.addPixmap(QtGui.QPixmap(":/common/icon/bloque_internet.png"))
		self.iconDesblockInt = QtGui.QIcon()
		self.iconDesblockInt.addPixmap(QtGui.QPixmap(":/common/icon/desbloque_internet.png"))

		# usuarios registrados en los grupos guardados en local.
		self.usersLocales = dict()

		# usuarios en conexión. Se actualizará en el método update_gui.
		self.users = dict()

	def set_handlers(self, handlers, controldesktop_handlers, controleditor_handlers):
		self.handlers = handlers
		self.controldesktop_handlers = controldesktop_handlers
		self.controleditor_handlers = controleditor_handlers

	def setupSignals(self):
		#Boton Crear Grupos
		self.connect(self.btnNombreGrupo, QtCore.SIGNAL("clicked()"), self.manage_resource)
		#Boton Cerrar - Abrir Grupo
		self.connect(self.btnCerrarGrupo, QtCore.SIGNAL("toggled(bool)"), self.manage_open_close)
		#Boton Expulsar
		self.connect(self.btnExpulsar, QtCore.SIGNAL("clicked()"), self.expulsar)
		#Boton Prohibir
		self.connect(self.btnProhibir, QtCore.SIGNAL("clicked()"), self.prohibir)
		#Boton Readmitir
		self.connect(self.btnReadmitir, QtCore.SIGNAL("clicked()"), self.readmitir)
		#Boton cerrar grupo activo
		self.connect(self.btnTerminarGrupo, QtCore.SIGNAL("clicked()"), self.terminar)
		#Boton Eliminar grupo local
		self.connect(self.btnEliminarGrupo, QtCore.SIGNAL("clicked()"), self.eliminarGrupoLocal)
		#Boton Cambiar Nombre Alumno
		self.connect(self.btnCambiarNombre, QtCore.SIGNAL("clicked()"), self.cambiar_nombre)
		#Boton Guardar Configuracion
		self.connect(self.btnGuardarConf, QtCore.SIGNAL("clicked()"), self.guardarConf)
		#Ordenar por nombre    
		self.connect(self.checkBoxOrdenar, QtCore.SIGNAL("stateChanged(int)"), self.ordenar_nombre)
		#Menu Ayuda
		self.connect(self.actionAyuda, QtCore.SIGNAL("triggered()"), self.entradaAyuda)
		#Menu Acerca de
		self.connect(self.actionAcerca_de, QtCore.SIGNAL("triggered()"), self.acercaDe)
		#Activa el grupo seleccionado en el combo
		self.connect(self.btnActivar, QtCore.SIGNAL("clicked()"), self.grupoSeleccionado)
		#Hace doble click en un item del panelControl
		self.connect(self.panelControl, QtCore.SIGNAL("itemDoubleClicked(QListWidgetItem*)"), self.pulsaIcono)
		self.connect(self.panelControl, QtCore.SIGNAL("clicked(QListWidgetItem*)"), self.clickItem_panelcontrol)
		#Señal para activar el botones cuando se selecciona un alumno conectado
		self.connect(self.userList, QtCore.SIGNAL('itemClicked(QListWidgetItem *)'), self.estado_botones_userList)
		#Hacer click en boton volver panel control de usuario
		self.connect(self.btnVolver, QtCore.SIGNAL("clicked()"), self.volver)
		
		# Señal para el boton ver los gupos existentes en la red
		self.connect(self.btnGruposExistentes, QtCore.SIGNAL("clicked()"), self.show_grupos)
		#Señal para cerrar la interfaz
		self.connect(self.actionSalir, QtCore.SIGNAL("activated()"), self.close)
		#Señal para boton x (cerrar ventana)
		self.connect(self, QtCore.SIGNAL('triggered()'), self.closeEvent)
		# Cambiar el nombre del usuario servidor
		self.connect(self.actionCambiarNombre, QtCore.SIGNAL("triggered()"), self.cambiarNombreServidor)
		#Señal para menu contextual de usuarios conectados
		self.userList.setContextMenuPolicy(QtCore.Qt.CustomContextMenu)
		self.connect(self.userList, QtCore.SIGNAL("customContextMenuRequested(QPoint)"), self.on_context_menu)
		#Señal para menu contextual de usuarios en panel de control
		self.panelControl.setContextMenuPolicy(QtCore.Qt.CustomContextMenu)

		self.connect(self.btnMultimedia, QtCore.SIGNAL("clicked()"), self.emitir_streaming_conjunto)
		self.connect(self.btnMultimediaAlum, QtCore.SIGNAL("clicked()"), self.emitir_streaming_individual)

		# Señales menú contextual lista de usuarios 
		self.cambiarNom.triggered.connect(self.cambiar_nombre)
		self.banea.triggered.connect(self.prohibir)
		self.expulsa.triggered.connect(self.expulsar)
		self.help.triggered.connect(self.cancelar_ayuda)

		# Signals from others threads (Qt.AutoConnection / Qt.QueuedConnection):
		self.connect(self, QtCore.SIGNAL("msgReceived"), self._message, QtCore.Qt.QueuedConnection)
		self.connect(self, QtCore.SIGNAL("volver"), self.volver, QtCore.Qt.QueuedConnection)
		self.connect(self, QtCore.SIGNAL("update_tabla_desktop"), self.update_tabla, QtCore.Qt.QueuedConnection)
		self.connect(self, QtCore.SIGNAL("comprueba_panelControl"), self.comprueba_panelControl, QtCore.Qt.QueuedConnection)
		self.connect(self, QtCore.SIGNAL("comprueba_user_help"), self.comprueba_user_help, QtCore.Qt.QueuedConnection)
		self.connect(self, QtCore.SIGNAL("update_gui"), self.update_gui)
		self.connect(self, QtCore.SIGNAL("ProgressBar"), self.start_progressBar)
		self.connect(self, QtCore.SIGNAL("stopPBAR"), self.stop_progressBar)
		self.connect(self, QtCore.SIGNAL("grupoNuevoCreado"), self.estadoBotones_grupoActivo)

		#Señal para la configuracion del tiempo en el que se realizan las capturas de pantalla
		self.connect(self.actionTempo, QtCore.SIGNAL("activated()"), self.show_config_delay)

		#Señal para guardar archivo txt del grupo
		self.connect(self.guardar_grupo_actual, QtCore.SIGNAL("activated()"), self.guardarGrupoActual)

		#Señales para la importacion y exportacion de los grupos
		self.connect(self.exportar_grupo_txt, QtCore.SIGNAL("activated()"), self.exportarGrupoTxt)
		self.connect(self.importar_grupo_txt, QtCore.SIGNAL("activated()"), self.importarGrupoTxt)

		#Señales para el panel Compartir
		self.connect(self.checkCompartir, QtCore.SIGNAL("stateChanged(int)"), self.activa_comp)
		self.connect(self.btnMisCompartidos, QtCore.SIGNAL("clicked()"), self.misCompartidos)
		self.connect(self.btnCompartidosAlum, QtCore.SIGNAL("clicked()"), self.compartidoAlum)
		self.connect(self.btnCompartir, QtCore.SIGNAL("clicked()"), self.compartir)
		self.connect(self.downloadbutton, QtCore.SIGNAL("clicked()"), self.descargar)
		self.connect(self.btnDirectorio, QtCore.SIGNAL("clicked()"), self.abrirDirectorio)

		#Señal que gestiona la ayuda al alumno
		self.connect(self, QtCore.SIGNAL("gestionar_ayuda_cliente"), self.gestionar_ayuda_cliente)


	## \fn emitir_streaming_individual(self)
	# \brief Emision de streaming para usuario individual, crea un objeto para el manejo de la nueva ventana multimedia, 
	# \al objeto del streaming se le pasa el usuario seleccionado del panelControl
	def emitir_streaming_individual(self):
		if self.comprobar_pid_vlc() == "" and self.usuario_select_stream == None and self.lista_usuarios_stream == False:
			self.sg_stream = SGestion_streaming(self, self.userSelected_panelControl)
		else:
			self._message(u"Estas emitiendo streaming, inténtalo más tarde.","information")

	## \fn emitir_streaming_conjunto(self)
	# \brief Emision de streaming para el grupo, crea un objeto para el manejo de la nueva ventana multimedia
	def emitir_streaming_conjunto(self):
		if self.comprobar_pid_vlc() == "" and self.lista_usuarios_stream == False and self.usuario_select_stream == None:
			self.sg_stream = SGestion_streaming(self)
		else:
			self._message(u"Estas emitiendo streaming, inténtalo más tarde.","information")

	## \fn comprobar_pid_vlc(self)
	# \brief Comprueba si existe algun proceso vlc activo
	# \return pid_vlc el resultado de la ejecucion de la sentencia
	def comprobar_pid_vlc(self):
		pid_vlc = commands.getoutput('netstat -np 2>/dev/null| grep :8080')
		return pid_vlc

	def comprueba_panelControl(self, nick):
		if self.fichaUsuario:
			if self.userSelected_panelControl[0] == nick:
				self.reset_panelcontrol()

	def update_gui(self, users):
		#Diccionario de usuarios donde se actualizan las listas de ellos.
		# users is a dict with at least the following keys: nick, jid, banned
		self.users = users

		# Actualización de usuarios conectados.
		self.good_users_conex = dict( [(u, self.users[u]) for u in self.users if not self.users[u]["banned"] ])
		self._update_list(self.good_users_conex)

		# Actualización lista usuarios baneados
		self.banned_users_conex = dict( [(u, self.users[u]) for u in self.users if self.users[u]["banned"] ])
		if self.subclaseBaneados != None:
			self.subclaseBaneados.emit(QtCore.SIGNAL('updateVentana'), self.banned_users_conex)
		
		# Actualización de usuarios guardados en grupo local
		if self.grupoLocal != None:
			self._add_local_users()

		# Actualización lista de usuarios bloqueados
		self.gui_cDesktop.actualizar_locklist(self.good_users_conex)

		# Actualización lista de usuarios para el bloqueo de internet
		self.gui_cDesktop.actualizar_locklistInternet(self.good_users_conex)

		enabled = bool(len(self.userList))
		
		#Actualización del combo que lista los grupos locales
		#self.update_lista_GruposLocal()
		self.reset_gui = False

		self.estado_botones_userList()
		self.estado_internet_grupal()

		if len(self.good_users_conex) == 0: #No tiene en cuenta los usuarios baneados
			self.btnGuardarConf.setEnabled(False)
			self.checkBoxOrdenar.setEnabled(False)
			self.checkBoxOrdenar.setChecked(False)
			self.guardar_grupo_actual.setEnabled(False)
			self.exportar_grupo_txt.setEnabled(False)

			self.userSelected_panelControl = None
			self.reset_panelcontrol()
		else:
			self.habilitar_panelControl()
			self.btnGuardarConf.setEnabled(True)
			self.guardar_grupo_actual.setEnabled(True)
			self.exportar_grupo_txt.setEnabled(True)
			self.checkBoxOrdenar.setEnabled(True)

	## \fn def estado_internet_grupal(self)
    # \brief Metodo que detecta si la accion grupal bloqueo de internet esta activa y asi 
    #  pasarle las caracteristicas al usuario nuevo conectado
	def estado_internet_grupal(self):
		if self.gui_cDesktop.blockInternet_grupo_status == True:
			self.gui_cDesktop.envia_senal_bloqInt_user(self.nuevo_user, True)

    #Actualiza la lista con los usuarios ordenados
	def _update_list(self, users):
		self.userList.clear()
		conectados = 0
		color1 = QtGui.QColor(255, 204, 204)
		if bool(users):
			for nick in users.keys():
				cargarItem = users.get(nick)
				item = QtGui.QListWidgetItem(cargarItem['nick'])
				if self.comprueba_lista_help(nick):
					item.setIcon(self.iconHelp)
					item.setBackgroundColor(color1)
				else:
					item.setIcon(self.icon39)
				item.setFlags(QtCore.Qt.ItemIsEnabled | QtCore.Qt.ItemIsSelectable)
				self.userList.addItem(item)
				conectados = conectados + 1

			if self.checkBoxOrdenar.isChecked():
				self.userList.sortItems()
		self.labelConectados.setText(str(conectados))

	# Añade a la lista de usuarios los usuarios guardados en el grupo local
	def _add_local_users(self):
		self.obtenerDiccionario(unicode(self.grupoLocal))
		users_local = dict( [(u, self.usersLocales[u]) for u in self.usersLocales])
		for nick in users_local.keys():
			if nick not in self.users.keys():
				cargarItem = users_local.get(nick)
				item = QtGui.QListWidgetItem(cargarItem['nick'])
				item.setIcon(self.icon38)
				item.setFlags(QtCore.Qt.NoItemFlags)
				self.userList.addItem(item)

		if self.checkBoxOrdenar.isChecked():
			self.userList.sortItems()

	## \fn update_tabla(self)
    # \brief Actualiza la imagen de los usuarios conectados a traves de las capturas realizadas
	def update_tabla(self):
		self.panelControl.clear()  #probar sin clear
		for i in self.good_users_conex.keys():
			ruta = os.path.join(DESKTOP_RUTA,i.strip(),"captura.jpg")
			imageC = QtGui.QImage(ruta)
			pixmap = QtGui.QPixmap()
			pixmap.convertFromImage(imageC)
			icon = QtGui.QIcon(pixmap)
			item = QtGui.QListWidgetItem()
			if not os.path.exists(ruta):
				item.setIcon(self.icon)
			else:
				item.setIcon(icon)
			item.setText(i)
			#Dar tamaño al item
			item.setSizeHint(QtCore.QSize(200, 160))
			self.panelControl.addItem(item)

			if self.fichaUsuario and self.userSelected_panelControl != None:
				if self.userSelected_panelControl[0] == i:
					self.dibuja_pixmap(item)
	
		if self.checkBoxOrdenar.isChecked():
			self.panelControl.sortItems()

	def clickItem_panelcontrol(self):
		users = [unicode(i.text()) for i in self.panelControl.selectedItems()]
		self.userSelected_panelControl = users

	def estado_botones_userList(self):
		# Si se está realizando una demostración de grupo
		# los botones deben mantenerse deshabilitados.
		if self.gui_cDesktop.demo_grupo_status: 
			self.btnProhibir.setEnabled(False)
			self.btnExpulsar.setEnabled(False)
			self.btnReadmitir.setEnabled(False)
			self.btnCambiarNombre.setEnabled(False)

			self.cambiarNom.setEnabled(False)
			self.banea.setEnabled(False)
			self.expulsa.setEnabled(False)

		else:
			# Comprobamos las listas de usuarios en el grupo y los baneados. Si no existen usuarios
			# se mantienen deshabilitados
			if self.good_users_conex != None and self.banned_users_conex != None:
				if len(self.good_users_conex) == 0 and len(self.banned_users_conex) == 0:
					self.btnProhibir.setEnabled(False)
					self.btnExpulsar.setEnabled(False)
					self.btnReadmitir.setEnabled(False)
					self.btnCambiarNombre.setEnabled(False)

					self.cambiarNom.setEnabled(False)
					self.banea.setEnabled(False)
					self.expulsa.setEnabled(False)
				else:
					if bool(self.userList.selectedItems()):
						users = [unicode(i.text()) for i in self.userList.selectedItems()]
						if self.gui_cDesktop.demo_grupo_status == False and self.gui_cDesktop.demoAlumnoActivo != users and self.gui_cDesktop.alumnoEmisionGrupo != users:
							# Se activan los botones solo en caso de que no se esté realizando una demostración de grupo
							# o en el caso en el que el usuario seleccionado no tiene una demostración activa
							self.btnProhibir.setEnabled(True)
							self.btnExpulsar.setEnabled(True)
							self.btnCambiarNombre.setEnabled(True)

							self.cambiarNom.setEnabled(True)
							self.banea.setEnabled(True)
							self.expulsa.setEnabled(True)
						else:
							self.btnProhibir.setEnabled(False)
							self.btnExpulsar.setEnabled(False)
							self.btnCambiarNombre.setEnabled(False)

							self.cambiarNom.setEnabled(False)
							self.banea.setEnabled(False)
							self.expulsa.setEnabled(False)
					else:
						self.btnProhibir.setEnabled(False)
						self.btnExpulsar.setEnabled(False)
						self.btnCambiarNombre.setEnabled(False)

						self.cambiarNom.setEnabled(False)
						self.banea.setEnabled(False)
						self.expulsa.setEnabled(False)

					if len(self.banned_users_conex) == 0:
						self.btnReadmitir.setEnabled(False)
					else:
						self.btnReadmitir.setEnabled(True)


	def pulsaIcono(self, item):	
		self.panelControl.setVisible(False)
		self.btnApagar.setEnabled(False)
		self.btnReiniciar.setEnabled(False)
		self.btnBloquear.setEnabled(False)
		self.btnEjecutarNav.setEnabled(False)
		self.btnEjecutaroffice.setEnabled(False)
		self.btnEjecutarOtra.setEnabled(False)
		self.btnMultimedia.setEnabled(False)
		self.btnMensaje.setEnabled(False)
		self.btnBloqNav.setEnabled(False)

		self.btnControl.setVisible(True)
		self.btnVisualizar.setVisible(True)
		self.btnDemostracionAlum.setVisible(True)
		self.btnEmiAluGrupo.setVisible(True)
		self.btnVolver.setVisible(True)
		self.labelNombre.setVisible(True)
		self.labelImagen.setVisible(True)
		self.labelIP.setVisible(True)
		self.label_nada.setVisible(True)
		self.btnApagarAlum.setVisible(True)
		self.btnReiniciarAlum.setVisible(True)
		self.btnBloquearAlum.setVisible(True)
		self.btnEjecutarNavAlum.setVisible(True)
		self.btnEjecutarOtraAlum.setVisible(True)
		self.btnEjecutarOfficeAlum.setVisible(True)
		self.btnBloqNavAlum.setVisible(True)

		self.btnMultimediaAlum.setVisible(True)
		self.btnMensajeAlum.setVisible(True)

		self.groupBox_Panel.setVisible(True)
		self.groupBox_Escritorio.setVisible(True)
		self.groupBox_Info.setVisible(True)
		self.groupBox_Acciones.setVisible(True)
		
		nombre = str(item.text()).strip()
		self.labelNombre.setText(u"Nombre de usuario: %s " %  nombre)
		self.dibuja_pixmap(item)

		users = [unicode(i.text()) for i in self.panelControl.selectedItems()]
		self.userSelected_panelControl = users
		self.fichaUsuario = True
		ip = self.users[users[0]].get('IP')
		self.labelIP.setText(u"Dirección IP: %s " %  ip)

		self.estado_botones_userList()
		self.gui_cDesktop.estado_botones_lockscreen()
		self.gui_cDesktop.estado_botones_demo()
		self.gui_cDesktop.estado_botones_bloqInternet()

	## \fn dibuja_pixmap(self, item)
    # \brief Actualiza las imagenes de los escritorios de los usuarios
    # \param item, item del usuario en concreto
	def dibuja_pixmap(self, item):
		pixmap = QtGui.QPixmap(item.icon().pixmap(200, 200))
		self.labelImagen.setPixmap(pixmap)
		self.labelImagen.setFixedSize(self.labelImagen.size())

	def volver(self):
		self.userSelected_panelControl = None
		
		self.panelControl.setVisible(True)
		self.btnControl.setVisible(False)
		self.btnVisualizar.setVisible(False)
		self.btnDemostracionAlum.setVisible(False)
		self.btnEmiAluGrupo.setVisible(False)
		self.btnVolver.setVisible(False)
		self.labelNombre.setVisible(False)
		self.labelImagen.setVisible(False)
		self.labelIP.setVisible(False)
		self.label_nada.setVisible(False)
		self.btnApagarAlum.setVisible(False)
		self.btnReiniciarAlum.setVisible(False)
		self.btnBloquearAlum.setVisible(False)
		self.btnEjecutarNavAlum.setVisible(False)
		self.btnEjecutarOtraAlum.setVisible(False)
		self.btnBloqNavAlum.setVisible(False)
		self.btnEjecutarOfficeAlum.setVisible(False)
		self.btnMultimediaAlum.setVisible(False)
		self.btnMensajeAlum.setVisible(False)

		self.groupBox_Panel.setVisible(False)
		self.groupBox_Escritorio.setVisible(False)
		self.groupBox_Info.setVisible(False)
		self.groupBox_Acciones.setVisible(False)

		self.habilitar_panelControl()

		self.fichaUsuario = False
		self.estado_botones_userList()
		self.gui_cDesktop.estado_botones_demo()
		self.gui_cDesktop.estado_botones_lockscreen()
		self.gui_cDesktop.estado_botones_bloqInternet()
		
	def habilitar_panelControl(self):
		if self.userSelected_panelControl == None:
			self.panelControl.setEnabled(True)
			self.btnDemostracion.setEnabled(True)
			self.btnApagar.setEnabled(True)
			self.btnReiniciar.setEnabled(True)
			self.btnBloquear.setEnabled(True)
			self.btnEjecutarNav.setEnabled(True)
			self.btnEjecutarOtra.setEnabled(True)
			self.btnEjecutaroffice.setEnabled(True)
			self.btnMultimedia.setEnabled(True)
			self.btnMensaje.setEnabled(True)
			self.btnBloqNav.setEnabled(True)

	def reset_panelcontrol(self):
		self.btnDemostracion.setEnabled(False)
		self.btnApagar.setEnabled(False)
		self.btnReiniciar.setEnabled(False)
		self.btnBloquear.setEnabled(False)
		self.btnEjecutarNav.setEnabled(False)
		self.btnEjecutarOtra.setEnabled(False)
		self.btnEjecutaroffice.setEnabled(False)
		self.btnMultimedia.setEnabled(False)
		self.btnMensaje.setEnabled(False)
		self.btnBloqNav.setChecked(False)
		self.btnBloqNav.setEnabled(False)

		self.panelControl.setVisible(True)
		self.panelControl.clear()
		self.btnControl.setVisible(False)
		self.btnVisualizar.setVisible(False)
		self.btnDemostracionAlum.setVisible(False)
		self.btnEmiAluGrupo.setVisible(False)
		self.btnVolver.setVisible(False)
		self.labelNombre.setVisible(False)
		self.labelImagen.setVisible(False)
		self.labelIP.setVisible(False)
		self.label_nada.setVisible(False)
		self.btnApagarAlum.setVisible(False)
		self.btnReiniciarAlum.setVisible(False)
		self.btnBloquearAlum.setVisible(False)
		self.btnEjecutarNavAlum.setVisible(False)
		self.btnEjecutarOtraAlum.setVisible(False)
		self.btnEjecutarOfficeAlum.setVisible(False)
		self.btnMultimediaAlum.setVisible(False)
		self.btnMensajeAlum.setVisible(False)


		self.groupBox_Panel.setVisible(False)
		self.groupBox_Escritorio.setVisible(False)
		self.groupBox_Info.setVisible(False)
		self.groupBox_Acciones.setVisible(False)

		self.btnApagar.setEnabled(False)
		self.btnReiniciar.setEnabled(False)
		self.btnBloquear.setEnabled(False)
		self.btnBloquear.setIcon(self.icon40)
		self.btnBloquear.setChecked(False)
		self.btnEjecutarNav.setEnabled(False)
		self.btnEjecutaroffice.setEnabled(False)
		self.btnEjecutarOtra.setEnabled(False)
		self.btnDemostracion.setEnabled(False)
		self.btnDemostracion.setIcon(self.icon31)
		self.btnDemostracion.setChecked(False)
		self.btnMultimedia.setEnabled(False)
		self.btnMensaje.setEnabled(False)

		self.userSelected_panelControl = None
		self.fichaUsuario = False

	#Crea el grupo
	def manage_resource(self):
		id_intr = 0

		if len(get_user_name()) == 0:
			identify_user()
		else:
			id_intr = 1
		
			res = str(self.textNombreGrupo.text().toUtf8())
			res = self.sanitize(res)
			if len(res) == 0 or len(res) > 32:
				self._message(u"<br>Debe escribir un nombre para el grupo (Max. 32 caracteres).","warning")
				return

			else:
				os.chdir(ROOM_RUTA)
				if os.path.exists(res):
					salida = self._message(u"Disponible un grupo guardado localmente con el mismo nombre. ¿Desea crear otro grupo con el mismo nombre?","question")
					if salida == 1:
						try:
							self.handlers["CREATE_RESOURCE_CB"](res)

						except SInvalidGroupName, name:
							self._message(QtCore.QString(u"Nombre de grupo inválido: \"<b>%1</b>\"<br>El nombre del grupo sólo puede contener caracteres alfanuméricos.").arg(unicode(name)),"warning")
							self.btnNombreGrupo.setChecked(False)
							self.textNombreGrupo.setText("")
							return

					else:
						self.handlers["DESTROY_RESOURCE_CB"]()
						self.btnTerminarGrupo.setEnabled(False)
						self.btnNombreGrupo.setEnabled(True)
						self.labelNombreGrupo.setText("")
						self.btnCerrarGrupo.setEnabled(False)
						self.checkCompartir.setEnabled(False)
						self.checkCompartir.setChecked(False)
						self.reset_panelCompartido()
				else:
					try:
						self.handlers["CREATE_RESOURCE_CB"](res)
					except SInvalidGroupName, name:
						self._message(QtCore.QString(u"Nombre de grupo inválido: \"<b>%1</b>\"<br>El nombre del grupo sólo puede contener caracteres alfanuméricos.").arg(unicode(name)), "warning")
						self.btnNombreGrupo.setChecked(False)
						self.textNombreGrupo.setText("")
						return

	def estadoBotones_grupoActivo(self, nombreMuc):
		self.reset_gui = False
		self.labelNombreGrupo.setText(nombreMuc)
		self.btnNombreGrupo.setEnabled(False)
		self.btnCerrarGrupo.setEnabled(True)
		self.comboBoxGrupos.setEnabled(False)
		self.btnActivar.setEnabled(False)
		self.btnEliminarGrupo.setEnabled(False)
		self.btnTerminarGrupo.setEnabled(True)
		self.label_3.setEnabled(True)
		self.labelConectados.setEnabled(True)
		self.textNombreGrupo.setEnabled(False)

		self.checkCompartir.setEnabled(True)
		if self.grupoLocal != None:
			self._add_local_users()
			self.textNombreGrupo.setText(self.grupoLocal)
		
	#Actualiza los elementos cuando un grupo termina
	def _reset_gui(self):
		self.reset_gui = True
		self.reset_panelcontrol()
		self.textNombreGrupo.setText("")
		self.textNombreGrupo.setEnabled(True)
		self.btnNombreGrupo.setEnabled(True)
		self.labelNombreGrupo.setText(" ")
		self.btnCerrarGrupo.setIcon(self.icon20)
		self.btnCerrarGrupo.setToolTip("Bloquear grupo")
		self.btnCerrarGrupo.setEnabled(False)
		self.btnCerrarGrupo.setChecked(False)
		self.btnTerminarGrupo.setEnabled(False)
		self.btnGuardarConf.setEnabled(False)
		self.guardar_grupo_actual.setEnabled(False)
		self.exportar_grupo_txt.setEnabled(False)
		self.comboBoxGrupos.setEnabled(True)
		self.btnExpulsar.setEnabled(False)
		self.btnProhibir.setEnabled(False)
		self.btnCambiarNombre.setEnabled(False)
		self.checkBoxOrdenar.setEnabled(False)
		self.checkBoxOrdenar.setChecked(False)
		self.label_3.setEnabled(False)
		self.labelConectados.setEnabled(False)
		self.btnEliminarGrupo.setEnabled(True)
		self.btnActivar.setEnabled(True)
		self.btnReadmitir.setEnabled(False)
		self.btnBloqNav.setEnabled(False)
		self.btnBloqNav.setChecked(False)

		self.gui_cDesktop.lockList = dict()
		self.gui_cDesktop.estado_botones_lockscreen()
		self.gui_cDesktop.demoAlumnoActivo = None
		self.gui_cDesktop.demo_grupo_status = False 
		self.gui_cDesktop.estado_botones_demo()
		self.gui_cDesktop.listaInternet = dict()
		

	#Metodo para mostrar mensaje de informativos
	def _message(self, msg, tipo):
		if tipo == "information":
			QtGui.QMessageBox.information(self, u"Información", msg)
		elif tipo == "about":
			QtGui.QMessageBox.about(self, u"Acerca de HGR", msg)
		elif tipo == "warning":
			QtGui.QMessageBox.warning(self, u"Atención", msg, u"Cerrar")
		elif tipo == "critical":
			QtGui.QMessageBox.critical(self, u"Error", msg, u"Ok")
		elif tipo == "question":
			salida = QtGui.QMessageBox.question(self, u"Atención", msg, u"No", u"Sí", defaultButtonNumber = 1)
			return salida

	#Menu Acerca De
	def acercaDe(self):
		msg = QtCore.QString(u"""Herramienta de Gestion de Recursos CGA 2016""")
		self._message(msg,"about")


	#Menu Ayuda
	def entradaAyuda(self):
		os.system("/usr/bin/xdg-open /usr/share/docs/HGR/Manual_de_Usuario_HGR.pdf")  



	""" ******************************* """
	""" Funciones sobre el grupo activo """
	""" ******************************* """

	# Bloquea o desbloquea el grupo para que pueda unirse o no mas usuarios.
	# El usuario que se haya conectado al menos una vez, salvo que esté baneado, podrá
	# volver a conectarse aunque el estado del grupo sea bloqueado.
	def manage_open_close(self, status):
		if not self.reset_gui:
			if status == True:
				self.handlers["CLOSE_MUC_CB"]()
				self.btnCerrarGrupo.setIcon(self.icon19)
				self.btnCerrarGrupo.setToolTip("Desbloquear grupo")
			else:
				self.handlers["OPEN_MUC_CB"]()
				self.btnCerrarGrupo.setIcon(self.icon20)
				self.btnCerrarGrupo.setToolTip("Bloquear grupo")
		self.reset_gui = False


	# Expulsa a un usuario de un grupo. Los usuarios expulsados pueden volver a conectarse
	def expulsar(self):
		if len(self.userList.selectedItems()) != 0:
			users = [unicode(i.text()) for i in self.userList.selectedItems()]

			if self.gui_cDesktop.demoAlumnoActivo != users:
				if self.gui_cDesktop.usuario_bloqueado(users[0]):
					salida = self._message(u"El usuario seleccionado tiene el equipo bloqueado. Si lo expulsa del grupo, se desbloqueará.<br> ¿Desea expulsarlo?", "question")
					if salida == 1:
						map(self.handlers["KICK_USER_CB"],users)
				elif self.usuario_select_stream == users[0] or self.lista_usuarios_stream == True:
					self.gestion_stream(users, "expulsar")
				else:
					map(self.handlers["KICK_USER_CB"],users)
			else:
				self._message(u"No puede expulsar el acceso a un alumno al que está realizando una demostración.", "warning")
		else:
			self._message(u"Debe seleccionar un usuario.", "information")

	def gestion_stream(self, users, tipo):
		if tipo == "expulsar":
			salida = self._message(u"El usuario seleccionado esta reproduciendo un video. Si lo expulsa del grupo, dejará de visualizarlo.<br> ¿Desea expulsarlo?", "question")
			if salida == 1:
				map(self.handlers["KICK_USER_CB"],users)
		else:
			salida = self._message(u"El usuario seleccionado esta reproduciendo un video. Si le prohibe el acceso al grupo, dejará de visualizarlo.<br> ¿Desea prohibirle el acceso?", "question")
			if salida == 1:
				map(self.handlers["BAN_USER_CB"],users)
		
	# Prohibe a un usuario el acceso a un grupo. Este entrará en la lista de usuarios baneados
	# El usuario no podrá acceder al grupo hasta que no sea readmitido.
	def prohibir(self):
		if len(self.userList.selectedItems()) != 0:
			users = [unicode(i.text()) for i in self.userList.selectedItems()]
			
			if self.gui_cDesktop.demoAlumnoActivo != users:
				if self.gui_cDesktop.usuario_bloqueado(users[0]):
					salida = self._message(u"El usuario seleccionado tiene el equipo bloqueado. Si le prohibe el acceso al grupo, se desbloqueará.<br> ¿Desea prohibirle el acceso?", "question")
					if salida == 1:
						map(self.handlers["BAN_USER_CB"],users)
				elif self.usuario_select_stream == users[0] or self.lista_usuarios_stream == True: 
					self.gestion_stream(users, "banear")
				else:
					map(self.handlers["BAN_USER_CB"],users)
			else:
				self._message(u"No puede prohibir el acceso a un alumno al que está realizando una demostración.", "warning")
		else:
			self._message(u"Debe seleccionar un usuario.", "information")


	def verip(self, ip):
		map(self.handlers["IP_USER_CB"],users)


	# Readmite a un usuario el acceso a un grupo. Esto significa que se le vuelve a permitir el acceso
	# y no que vuelva a aparecer como usuario del grupo. Deberá volver a conectarse.
	def readmitir(self):
		self.banned_users_conex = dict( [(u, self.users[u]) for u in self.users if self.users[u]["banned"] ])
		if self.banned_users_conex != None:
			self.subclaseBaneados = SBaneados(self, self.banned_users_conex)
			self.subclaseBaneados.exec_()

	# Elimina el grupo activo.
	def terminar(self):
		self.estado_bloqInternet()
		self.grupoLocal = None
		self.lista_user_help = dict()
		ldebug("GUI :: Delete resource\n%s\n" % ('-'*80))
		self.handlers["DESTROY_RESOURCE_CB"]()
		self.checkCompartir.setEnabled(False)
		self.checkCompartir.setChecked(False)
		self.reset_panelCompartido()
		ldebug("Interface reset\n%s\n" % ('-'*80))
		self._reset_gui()

	# recorre la lista de ususarios bloqueadosInternet y si alguno la tiene activada, envia la señal para dejarle navegar
	def estado_bloqInternet(self):
		for nick in self.gui_cDesktop.listaInternet.keys():
			if self.gui_cDesktop.listaInternet[nick] == True:
				self.gui_cDesktop.envia_senal_bloqInt_user(nick, False)

	def cambiarNombreServidor(self):
		self.handlers["CAMBIAR_NOMBRE_SERVER"]()

	def cambiar_nombre(self):
		if len(self.userList.selectedItems()) != 0:
			users = [unicode(i.text()) for i in self.userList.selectedItems()]
			if not self.gui_cDesktop.usuario_bloqueado(users[0]) and self.usuario_select_stream != users[0] and self.lista_usuarios_stream == False:
				if self.gui_cDesktop.demoAlumnoActivo != users:
						subclase = identifyWindow(users, self)
						subclase.exec_()			
			else:
				if self.usuario_select_stream == users[0] or self.lista_usuarios_stream == True:
					self._message(u"No puede cambiar el nombre de un usuario mientras este reproducciendo.", "warning")
				elif self.gui_cDesktop.demoAlumnoActivo == users:
					self._message(u"Está realizando una demostración al alumno. Finalice para cambiarle el nombre.", "warning")
				else:
					self._message(u"No puede cambiar el nombre de un usuario bloqueado.", "warning")
		else:
			self._message(u"Debe seleccionar un usuario.", "information")

	#Menu contextual de alumnos conectados
	def on_context_menu(self, QPos):
		self.estado_botones_userList()
		user = [unicode(i.text()) for i in self.userList.selectedItems()]
		self.gestiona_menu_help(user)
		if bool(user):
			self.parenPosition = self.userList.mapToGlobal(QtCore.QPoint(1,10))
			self.popMenu.move(self.parenPosition + QPos)
			self.popMenu.show()

	#Ordena la lista de nombre de usuarios
	def ordenar_nombre(self):
		self.handlers["ORDER_NAME"]()

	def sms_user(self):
		users = [unicode(i.text()) for i in self.userList.selectedItems()]
		map( self.handlers["SMS_USER_CB"], users)

	""" ******************************* """
	""" Funciones para ayuda al usuario """
	""" ******************************* """

	def gestionar_ayuda_cliente(self, nick):
		self.help.setEnabled(True)
		self.lista_user_help[nick]=nick
		self.update_gui(self.good_users_conex)

	def gestiona_menu_help(self, user):
		if user[0] in self.lista_user_help:
			self.help.setEnabled(True)
		else:
			self.help.setEnabled(False)

	def comprueba_lista_cambioN(self, userHelp):
		if userHelp in self.lista_user_help:
			self.usuario_help_cambio(userHelp)
		else:
			self.flagHelp = None
	
	def comprueba_lista_help(self, userHelp):
		if userHelp in self.lista_user_help:
			return True
		else:
			return False
	
	def cancelar_ayuda(self):
		self.help.setEnabled(False)
		userHelp = [unicode(i.text()) for i in self.userList.selectedItems()]
		if userHelp[0] in self.lista_user_help:
			del self.lista_user_help[userHelp[0]]
	
		self.update_gui(self.good_users_conex)
		self.handlers["HABILITA_AYUDA_USER"](userHelp[0])


	def comprueba_user_help(self, nick):
		if nick in self.lista_user_help:
			del self.lista_user_help[nick]

	def usuario_help_cambio(self, nickInicial):
		del self.lista_user_help[nickInicial]
		self.lista_user_help[self.flagHelp]=self.flagHelp
		self.flagHelp = None


	""" ****************************************************************  """
	""" Funciones para la actualización del listado de los grupos locales """
	""" ****************************************************************  """

	#Elimina un grupo de la lista de grupos locales
	def eliminarGrupoLocal(self):
		if self.comboBoxGrupos.currentText()=="":
			self._message(u"Actualmente no existen grupos guardados localmente.", "information")
		else:
			nomArch = self.comboBoxGrupos.currentText()
			salida = self._message(u"Va a eliminar el grupo "+unicode(nomArch)+", ¿Desea borrarlo?", "question")
			if salida == 1:
				path = os.path.join(ROOM_RUTA,unicode(nomArch))
				os.remove(os.path.abspath(path))
				self.update_lista_GruposLocal()


	#Actualiza el combo de los grupos locales
	def update_lista_GruposLocal(self):
		self.comboBoxGrupos.clear()
		for base, dirs, files in os.walk(ROOM_RUTA):
			for grupo in files:
				self.comboBoxGrupos.addItem(unicode(grupo))
		if len(self.comboBoxGrupos) == 0:
			self.btnActivar.setEnabled(False)
			self.btnEliminarGrupo.setEnabled(False)
		elif len(self.comboBoxGrupos) != 0 and self.textNombreGrupo.text() == "":
			self.btnActivar.setEnabled(True)
			self.btnEliminarGrupo.setEnabled(True)

	""" ******************************* """
	""" Gestión ficheros grupos locales """
	""" ******************************* """
	def importarGrupoTxt(self):
		self.ventanaDialog(2)
		result=self.fname.exec_()

		if result == 1:
			ruta_import = self.fname.selectedFiles()[0]
			ruta_import = str(ruta_import)

			if ruta_import.endswith('.hgr'):
				self.guardarConf(ruta_import)
			else:
				self._message(u"Debe seleccionar un archivo de grupo para importar.","information")

	def exportarGrupoTxt(self):
		nomGrupo = unicode(self.textNombreGrupo.text())
		nomGrupo = self.sanitize(nomGrupo)
		self.ventanaDialog(1)
		
		result=self.fname.exec_()
		if result == 1:
			ruta_export = self.fname.selectedFiles()[0]

			if not str(ruta_export).endswith('.hgr'):
				ruta_export = str(ruta_export)+".hgr"
			
			self.usersLocales = self.users
			self.archivo = open(os.path.abspath(str(ruta_export)), 'w')
			self.archivo.write(str(self.usersLocales))
			self.archivo.close()

	def ventanaDialog(self, tipo):
		self.fname = QtGui.QFileDialog(self)
		self.fname.setFileMode(1)
		target = os.environ.get('HOME') + os.path.sep + "Descargas" 
		self.fname.setDirectory(QtCore.QString(target))
		self.fname.setFileMode(QtGui.QFileDialog.AnyFile)
		self.fname.setLabelText(QtGui.QFileDialog.LookIn,"Ruta del sistema")
		self.fname.setLabelText(QtGui.QFileDialog.Reject,"Cancelar")
		self.fname.setLabelText(QtGui.QFileDialog.FileType,u"Tipo de extensión permitida")

		self.tipoFile(tipo)


	def tipoFile(self, tipo):
		if tipo == 1:
			fileName = "Nombre del grupo"
			btnAceptar = "Guardar"
			filtros = "Grupos (*.hgr)"
			tituloVentana = "Exportar grupo"
		elif tipo == 2:
			fileName = "Grupo a importar"
			btnAceptar = "Importar"
			filtros = "Grupos (*.hgr)"
			tituloVentana = "Importar grupo"
		elif tipo == 3:
			fileName = "Nombre del grupo"
			btnAceptar = "Guardar"
			filtros = "Texto (*.txt)"
			tituloVentana = "Guardar grupo"
		elif tipo == 4:
			fileName = "Abrir archivo"
			btnAceptar = "Abrir"
			filtros = FILTROS_STREAMING
			tituloVentana = "Abrir archivo multimedia"

		self.fname.setLabelText(QtGui.QFileDialog.FileName,fileName)
		self.fname.setLabelText(QtGui.QFileDialog.Accept,btnAceptar)
		self.fname.setFilter(filtros)
		self.fname.setWindowTitle(tituloVentana)


	def guardarGrupoActual(self):
		self.ventanaDialog(3)
		result=self.fname.exec_()

		if result == 1:
			fichero_grupo = self.fname.selectedFiles()[0]
			if not os.path.exists(fichero_grupo):
				archivo_grupo_txt = open(os.path.abspath(str(fichero_grupo)), 'w')
				archivo_grupo_txt.write(str(self.labelNombreGrupo.text())+": ")
				archivo_grupo_txt.write('\n')
				archivo_grupo_txt.write('-----------------------')
				archivo_grupo_txt.write('\n\n')

				users_local = dict( [(u, self.users[u]) for u in self.users])
				for nick in users_local.keys():
					archivo_grupo_txt.write('- Nombre: '+str(nick).strip()+', IP: '+users_local.get(nick)['IP'])
					if users_local.get(nick)['banned'] == True:
						archivo_grupo_txt.write(', Baneado: Si')
					else:
						archivo_grupo_txt.write(', Baneado: No')
					archivo_grupo_txt.write('\n')
				
				archivo_grupo_txt.close()

	# Metodo para guardar la configuracion de un grupo: nombre del grupo, lista de usuarios conectados
	# y lista de usuarios baneados.
	def guardarConf(self, ruta_import=None):
		if ruta_import == None:
			self.grupoLocal = unicode(self.textNombreGrupo.text())
			self.grupoLocal = self.sanitize(self.grupoLocal)
		else:
			stringNombre = ruta_import.split("/")
			nombreGrupo = stringNombre[len(stringNombre)-1].split('.')
			self.grupoLocal = nombreGrupo[0]

		if not os.path.exists(ROOM_RUTA):
			os.mkdir(ROOM_RUTA)
		
		path = os.path.join(ROOM_RUTA,str(self.grupoLocal))
		if os.path.exists(os.path.abspath(path)):
			salida = self._message(u"<br>El grupo ya existe, ¿desea sobreescribirlo?", "question")
			if salida == 1:
				try:
					os.remove(os.path.abspath(path))
					if ruta_import == None:
						self.escribirFichero(path)
					else:
						self.importar(ruta_import, nombreGrupo[0])
				except Exception, e:
					lerror("Error al administrar fichero: '%s'" % e)
					self._message(u"No se ha podido guardar la Información, vuelva a intentarlo.","information")
			else:
				self._message(u"<br>No ha guardado el grupo.", "information")
		else:
			if ruta_import == None:
				self.escribirFichero(path)
			else:
				self.importar(ruta_import, nombreGrupo[0])

	def importar(self, ruta, nombreG):
		sentCp = "cp '"+ruta+"' "+ROOM_RUTA
		os.system(sentCp)
		os.chdir(ROOM_RUTA)
		nombreGs = self.sanitize(nombreG)
		sentMv = "mv '"+nombreG+"'.hgr"+" "+nombreGs
		os.system(sentMv)
		self.update_lista_GruposLocal()

	# Crea un fichero y escribe el diccionario de usuarios del grupo.
	def escribirFichero(self, ruta):
		if ruta:
			self.usersLocales = self.users
			self.archivo = open(os.path.abspath(ruta), 'w')
			self.archivo.write(str(self.usersLocales))
			self.archivo.close()
			self.update_lista_GruposLocal()
			#Las añadimos a los listados de la UI
			self._update_list(self.good_users_conex)
			self._add_local_users()
		else:
			self._message(u"No se ha encontrado nombre para el grupo.", "warning")

	#Metodo para rellenar el combo con los grupos guardados
	def comboGrupos(self):
		for base, dirs, files in os.walk(os.path.abspath(ROOM_RUTA)):
			for grupo in files:
				self.comboBoxGrupos.addItem(unicode(grupo))


	#Metodo para Abrir un grupo seleccionado en el combo
	def grupoSeleccionado(self):
		if self.comboBoxGrupos.currentText()=="":
			self._message(u"Actualmente no existen grupos guardados localmente.", "information")
		else:
			self.grupoLocal = unicode(self.comboBoxGrupos.currentText())
			self.handlers["CREATE_RESOURCE_CB"](self.grupoLocal)

	def obtenerDiccionario(self,nomArch):
		# Nos situamos en el directorio (ROOM_RUTA) para leer el fichero seleccionado,
		# lo abrimos y obtenemos la lista de usuarios del mismo.
		path = os.path.join(ROOM_RUTA,str(nomArch))
		if os.path.exists(os.path.abspath(path)):
			self.archivo = open(os.path.abspath(path), 'r')
			self.usersLocales = ast.literal_eval(self.archivo.read())
			self.archivo.close()
		else:
			self._message(u"El fichero asociado al grupo seleccionado no existe.", "information")

	def show_grupos(self):
		self.handlers["VIEW_RESOURCES"]()

	""" ***************************** """
	"""    Gestion barra de progreso  """
	""" ***************************** """
	def start_progressBar(self, procesoKey, command, nick=None):
		if self.procesos_progressBar == None:
			self.procesos_progressBar = ProgressBar_thread()
			self.procesos_progressBar.set_config(command, procesoKey)
			if nick != None:
				ip = self.users.get(nick)['IP']
				self.procesos_progressBar.set_ipUser(ip)
			self.procesoKey = procesoKey
			self.progressBar.setRange(0,0)
			self.progressBar.setVisible(True)
			self.connect(self.procesos_progressBar, QtCore.SIGNAL("finished()"), self.stop_progressBar)
			self.procesos_progressBar.start()

	def stop_progressBar(self):
		pid = None
		if self.procesos_progressBar != None:
			pid = self.procesos_progressBar.pid
		self.progressBar.setRange(0,1)
		self.progressBar.setVisible(False)
		self.procesos_progressBar = None
		self.return_proceso_solicitado(pid)

	def return_proceso_solicitado(self, pid=None):
		if self.procesoKey == KEY_DEMOGRUPO:
			self.emit(QtCore.SIGNAL('estadoDemoGrupo'),True)
		if self.procesoKey == KEY_DEMOALUM:
			self.emit(QtCore.SIGNAL('estadoDemo'),True)
		elif self.procesoKey == KEY_DOC:
			self.emit(QtCore.SIGNAL("serverStart"), True, pid)
		self.procesoKey = None

	""" ************************** """

	#Metodo para cerrar la ventana
	def closeEvent(self, event):
		self.estado_bloqInternet()
		QtGui.qApp.closeAllWindows()
		self.handlers["CLOSE_EVENT_CB"]()


	## \fn show_config_delay(self)
	# \brief Muestra la ventana de seleccion del tiempo a pasar entre captura y captura
	def show_config_delay(self):
		self.ventana_zoom = STemp_capturas(self)

	""" ****************************************** """
	""" Funciones para la comparticion de archivos """
	""" ****************************************** """

	## \fn activa_comp(self, estado)
	#\brief Boton checked para activar o desactivar la comparticion de archivos
	def activa_comp(self, estado):
		if self.checkCompartir.isChecked() == True:
			self.handlers["SHARED_CB"](estado)
			self.reset_misCompartidos()
			self.data = self.handlers["GET_SHARED_INFO_SERVER"]()
			self.data['group'] = self.data['group']
			self.data['nick'] = self.sanitize(self.data['nick'])

			if estado:
				self.show_shared_info()
				self.misCompartidos()

		else:
			self.reset_panelCompartido()
			self.handlers["SHARED_CB"](estado)

			
	def sanitize(self, data):
		data = data.lstrip()
		data = data.replace(' ', '_')
		for a,b in ( ('á', 'a'), ('é', 'e'), ('í', 'i'), ('ó', 'o'), ('ú', 'u'), ('ñ', 'n'),
			('Á', 'A'), ('É', 'E'), ('Í', 'I'), ('Ó', 'O'), ('Ú', 'U'), ('Ñ', 'N') ):
			data=data.replace(a, b)
		data = str(filter(lambda k: k in VALID_CHARS, data)).lower()
		return data



    ## \fn show_shared_info(self)
    # \brief Muestra un cuadro de diálogo acerca de la aplicación de intercambio de información.
    # El usuario puede optar por no mostrar el diálogo de nuevo.
	def show_shared_info(self):
		self.share = SSharedDir(self.data['group'])
		PRIVATE_DIR=os.path.join(self.share.SHARED_PRIVATE_DIR)
		info = QtGui.QApplication.tr(self, unicode(SHARED_INFO_TEXT)).arg(self.share.SHARED_PROFE).arg(self.share.SHARED_ALUM)
		show_shared_help = self.settings.value("shared/show_help", QtCore.QVariant(True)).toBool()
		# Does the user want to see the dialog?
		if show_shared_help:
			ret = SShowInfoAgain(info)
			ret.exec_()
			if not ret.ask():
				ldebug("No se mostrará más")
				show_shared_help=False
				linfo("Estableciendo la configuracion a %s" % show_shared_help)
				self.settings.setValue("shared/show_help", QtCore.QVariant(show_shared_help))
			

	## \fn misCompartidos(self)
	# \brief Crea un QFileSystemModel en un QTreeView. Se muestran los archivos compartidos por el profesor.
	def misCompartidos(self):
		self.reset_misCompartidos()
		self.startDir = QtCore.QString("")
		self.startDir = self.share.SHARED_PROFE
		self.model = QtGui.QFileSystemModel()
		self.model.setFilter(QtCore.QDir.AllDirs | QtCore.QDir.NoDotAndDotDot | QtCore.QDir.AllEntries)
		self.model.setNameFilterDisables(0)
		self.model.setRootPath(self.startDir)

		self.panelCompartido.setModel(self.model)
		self.panelCompartido.setRootIndex(self.model.index(self.startDir))
		self.panelCompartido.header().setResizeMode(0, QtGui.QHeaderView.ResizeToContents)



	## \fn compartidoAlum(self)
	# \brief Crea un QFileSystemModel en un QTreeView. Se muestran los archivos compartidos por los alumnos.
	def compartidoAlum(self):
		self.reset_compartidosAlum()
		self.startDir = self.share.SHARED_ALUM
		self.panelCompartido.setModel(self.model)
		self.panelCompartido.setRootIndex(self.model.index(self.startDir))


	## \fn compartir(self)
	# \brief Se implementa la funcionalidad para el profesor del botón compartir ficheros.
	def compartir(self):
		ruta = self.share.SHARED_PROFE
		index = self.panelCompartido.currentIndex()
		directorio = self.model.filePath(index)
		explorer = QtGui.QFileDialog.getOpenFileName(self, 'Compartir archivo', HOMEDIR, 'All files (*)')
		if explorer != '':
			if directorio == '':
				shutil.copy(str(explorer), ruta)
			elif os.path.isdir(directorio):
				shutil.copy(str(explorer), str(directorio))
			else:
				self._message(u"<br>No se ha podido compartir el archivo. Vuelva a intentarlo.","critical")


	## \fn descargar(self)
	# \brief Se implementa la funcionalidad para el profesor del botón descargar ficheros de los alumnos.
	def descargar(self):
		index = self.panelCompartido.currentIndex()
		fichero = self.model.filePath(index)
		archivo = self.model.fileName(index)
		ruta = HOMEDIR + os.path.sep + "Descargas" + os.path.sep + archivo		
		try:
			if fichero == '':
				self._message(u"<br>No has seleccionado ningún archivo para descargar.","warning")
			else:
				explorer = QtGui.QFileDialog.getSaveFileName(self, 'Guardar archivo', ruta, "All files(*)")
				if explorer != '':
					shutil.copy(str(fichero), explorer)
					self._message(u"<br>Archivo descargado con éxito.","information")
		except:
			self._message(u"<br>Descarga fallida. Vuelva a intentarlo.","critical")


	def abrirDirectorio(self):
		ejec = commands.getoutput('nautilus ' + self.startDir)


	## \fn reset_panelCompartido(self)
	#\brief Deshabilita los botones del panel compartido cuando sea necesario
	def reset_panelCompartido(self):
		self.btnMisCompartidos.setEnabled(False)
		self.btnMisCompartidos.setChecked(False)
		self.btnCompartidosAlum.setEnabled(False)
		self.btnCompartidosAlum.setChecked(False)
		self.btnCompartir.setEnabled(False)
		self.downloadbutton.setEnabled(False)
		self.btnDirectorio.setEnabled(False)
		self.btnDirectorio.setToolTip("Abrir directorio de archivos compartidos")
		self.panelCompartido.setEnabled(False)
		self.panelCompartido.reset()


	## \fn reset_misCompartidos(self)
	#\brief Habilita los botones cuando el panelCompartido muestre los archivos compartidos del profesor. (Por defecto lo es)
	def reset_misCompartidos(self):
		self.btnMisCompartidos.setEnabled(True)
		self.btnMisCompartidos.setChecked(True)
		self.btnCompartidosAlum.setChecked(False)
		self.btnCompartidosAlum.setEnabled(True)
		self.btnCompartir.setEnabled(True)
		self.downloadbutton.setEnabled(False)
		self.panelCompartido.setEnabled(True)
		self.btnDirectorio.setEnabled(True)
		self.btnDirectorio.setToolTip("Abrir mi directorio de archivos compartidos")


	## \fn reset_compartidosAlum(self)
	#\brief Habilita los botones cuando el panelCompartido muestre los archivos compartidos de los alumnos
	def reset_compartidosAlum(self):
		self.btnMisCompartidos.setEnabled(True)
		self.btnMisCompartidos.setChecked(False)
		self.btnCompartidosAlum.setEnabled(True)
		self.btnCompartidosAlum.setChecked(True)
		self.btnCompartir.setEnabled(False)
		self.downloadbutton.setEnabled(True)
		self.panelCompartido.setEnabled(True)
		self.btnDirectorio.setToolTip("Abrir directorio de archivos compartidos de alumnos")

	
if __name__=="__main__":
	s = SGestion()
	app = QtGui.QApplication(sys.argv)
	s.show()
	app.exec_()

class identifyWindow(QtGui.QDialog):
	def __init__(self, users, gestion, parent=None):
		super(identifyWindow, self).__init__()
		self.settings=QtCore.QSettings()
		self.gestion=gestion
		self.center()
		self.users=users
		self.nombreInicial = users[0].strip(' ')
		label=QtGui.QLabel(u"""Indique el nombre del usuario:""")
		self.tNombre=QtGui.QLineEdit()
		self.tNombre.setMaxLength(25)
		self.tNombre.setText(self.nombreInicial)
		self.bAceptar=QtGui.QPushButton("Aceptar")
		self.bAceptar.setEnabled(False)

		self.connect(self.bAceptar, QtCore.SIGNAL("clicked()"), self.enterUserName)
		self.tNombre.textChanged.connect(self.habilitarAceptar)

		layout=QtGui.QVBoxLayout()
		layout.addWidget(label)
		layout.addWidget(self.tNombre)
		layout.addWidget(self.bAceptar)
		self.setLayout(layout)

		self.setWindowIcon(QtGui.QIcon(":/common/icon/avatar.png"))

		self.setWindowTitle(u"Identificación")


	def enterUserName(self):
		username=str(self.tNombre.text().toUtf8())
		username = self.sanitize_name(username)
		if len(username.strip(' ')) > 0:
			self.gestion.flagHelp = " "+username
			self.gestion.comprueba_lista_cambioN(" "+self.nombreInicial)
			username = [username]
			self.close()
			map(self.gestion.handlers["IDENTIFY_USER_CB"],self.users,username)

	def habilitarAceptar(self):
		username = str(self.tNombre.text().toUtf8())
		username = self.sanitize_name(username.strip(' '))
		if len(username.strip(' ')) > 0 and username != self.users[0].strip(' '):
			self.bAceptar.setEnabled(True)
		else:
			self.bAceptar.setEnabled(False)

	def center(self):
		GeoFrame = self.frameGeometry()
		center = QtGui.QDesktopWidget().availableGeometry().center()
		GeoFrame.moveCenter(center)
		self.move(GeoFrame.topLeft())


	def sanitize_name(self, data):
		data = data.lstrip()
		for a,b in ( ('á', 'a'), ('é', 'e'), ('í', 'i'), ('ó', 'o'), ('ú', 'u'), ('ñ', 'n'),
			('Á', 'A'), ('É', 'E'), ('Í', 'I'), ('Ó', 'O'), ('Ú', 'U'), ('Ñ', 'N') ):
			data=data.replace(a, b)
		data = str(filter(lambda k: k in VALID_CHARS, data))
		return data