# -*- coding: utf-8 -*-
##\namespace 

import sys
import os
import logging
import logging.config
import time

from PyQt4.QtCore import *
from PyQt4.QtGui import *

from threading import Lock

from hga.gui.servidor.ui_grupos import Ui_MainGrupos


class SGruposRed(QMainWindow, Ui_MainGrupos):

	def __init__(self, core):
		super(SGruposRed, self).__init__(None)
		self.setupUi(self)
		self.core = core
		self.jid = self.core.jid
		self.users = self.core.users
		self.resource_list = {}
		self.resource_list_lock = Lock()
		self.mdns = self.core.mdns
		self.view_resources()


	def handle_resource_found(self, name, domain, address, port, info_dict):
		info_keys = info_dict.keys()
		if 'muc_jid' in info_keys and 'muc_name' in info_keys and 'prof_name' in info_keys and 'prof_jid' in info_keys:
			info_dict['service_name'] = name
			with self.resource_list_lock:
				self.resource_list[info_dict['muc_jid']] = info_dict
			self.update_resources(self.resource_list, self.jid, self.users)


	## \fn handle_resource_lost(self, *args)
	# \brief Handle the Resource Lost event.
	# \param *args Array with information about resource lost.
	def handle_resource_lost(self, *args):
		resource_index = None
		for resource in self.resource_list.values():
			if resource['service_name'] == args[0]:
				resource_index = resource['muc_jid']
				continue
		if resource_index is not None:
			resource = self.resource_list[resource_index]
			with self.resource_list_lock:
				del self.resource_list[resource_index]
			self.update_resources(self.resource_list, self.jid, self.users)


	#Modifica el listado de grupos existentes en la red.
	def update_resources(self, resource_list, jid, users):
		self.listWidget_GruposRed.clear()
		for resource in resource_list.values():
			item = QListWidgetItem(resource['muc_name'])
			item.setToolTip(resource['prof_name'])
			item.muc_jid = resource['muc_jid']
			self.listWidget_GruposRed.addItem(item)


	def view_resources(self):
		if self.mdns != None:
			self.mdns.browse(self.handle_resource_found, self.handle_resource_lost)