#!/usr/bin/env python
# -*- coding: utf-8 -*-

from PyQt4 import QtGui
from PyQt4.QtCore import QThread, SIGNAL
import time
import commands
import logging
from hga.controlgrupos.common.exception import NoDefaultDevice
from hga.controlgrupos.common.settings import LOGGING_CONFIG_FILE
from hga.controlgrupos.common.user_info import ping
from hga.controlgrupos.common.user_info import get_ip

from hga.controleditor.controleditor_server import KEY_DOC
from hga.controlgrupos.servidor.settingsservidor import KEY_SERVER

logging.config.fileConfig(LOGGING_CONFIG_FILE)
lerror = logging.error

## \class ProgressBar_thread
# \brief Qthread para controlar la ejecución de la barra de progreso
class ProgressBar_thread(QThread):
    def __init__(self):
        QThread.__init__(self)
        self.pid = None
        self.ip_remota = None

    ## \fn def set_config(self, command, procesoKey, handlers=None):
    # \brief Set para los parámetros que se requieren según la funcionalidad que realiza la petición.
    # \param command Comando a ejecutar si el servicio se encuentra disponible o no.
    # \param procesoKey Clave de la funcionalidad que realiza la solicitud.
    def set_config(self, command, procesoKey):
        self.command = command
        self.procesoKey = procesoKey

    ## \fn def set_ipUser(self, ipRemota):
    # \brief Set para el atributo ip de la clase. Según las funcionalidad que lo solicite, será necesario o no.
    # \param ipRemota Recibe la ip remota, si el comando a ejecutar para funcionalidad lo requiere.
    def set_ipUser(self, ipRemota):
        self.ip_remota = ipRemota

    def run(self):
        while self.pid == None or self.pid == "":
            result = commands.getstatusoutput(self.command)
            self.pid = result[1].strip()
            if self.procesoKey == KEY_SERVER:
                try:
                    get_ip()
                except NoDefaultDevice, e:
                    break
            elif result[0] != 0:
                self.pid = None
                lerror("thread_sgestion -> Error al ejecutar el comando.")
                break
            else:
                if self.procesoKey != KEY_DOC: #Se comprueba la conexión solo para las funcionalidades que dependen de ella.
                    if not ping(self.ip_remota):
                        self.pid = None
                        lerror("thread_sgestion -> No hay conexión.")
                        break
            