#!/usr/bin/python
# -*- coding: utf-8 -*-
## \namespace rpc

import sys

import commands

import netifaces

from hga.controlgrupos.common.irpcmodule import IRPCModule
from hga.controlgrupos.common.netdev import NetDev
#from hga.controlgrupos.common.user_info import sms_user
from hga.controlgrupos.common.user_info import identify_user

## \class RPC_identify(IRPCModule)
#  \brief 
class RPC_mensaje(IRPCModule):
    ## \fn  
    #  \brief 
    #  \param
    def __init__(self, core):
        self.name="SMS"
        self.core=core

    ## \fn  main(self)
    #  \brief   Ejecuta el cambio de identidad del alumno.
    def main(self):

        #self.core.salir_sala()
        sms_user()



## \class RPC_identify(IRPCModule)
#  \brief 
class RPC_identify(IRPCModule):
    ## \fn  
    #  \brief 
    #  \param
    def __init__(self, core):
        self.name="IDENTIFY"
        self.core=core

    ## \fn  main(self)
    #  \brief   Ejecuta el cambio de identidad del alumno.
    def main(self):
        self.core.salir_sala()
        identify_user()


## \class RPC_getMAC
#  \brief
class RPC_getMAC(IRPCModule):
    ## \fn __init__(self)
    #  \brief 
    #  \param
    def __init__(self, core=None):
        self.name="MAC"

    ## \fn  main(self)
    #  \brief Devuelve la MAC del router por defecto o None si no tiene MAC asignada
    #  \param
    #  \return MAC por defecto 
    def main(self):
        nd = NetDev()
        return nd.default_mac()

    ## \fn  
    #  \brief 
    #  \param
    #  \return 
    def __repr__(self):
        return "%s: %s" % (self.name, self.main())

if __name__=="__main__":
    r = RPC_getMAC()
    mac = r.main()
    print "MAC: %s" % mac


    ## \class RPC_getIP(IRPCModule)
#  \brief 
class RPC_getIP(IRPCModule):
    ## \fn  
    #  \brief 
    #  \param
    def __init__(self, core=None):
        self.name="IP"

    ## \fn  main(self)
    #  \brief Devuelve la IP del router por defecto o None si no tiene IP asignada
    def main(self):
        nd = NetDev()
        return nd.default_ip()

    ## \fn  
    #  \brief 
    #  \return
    def __repr__(self):
        return "%s: %s" % (self.name, self.main())

if __name__=="__main__":
    r = RPC_getIP()
    ip = r.main()
    print "IP: %s" % ip


#Clase necesaria para conectar a WebDav necesario para la comparticion de archivos
class RPC_sharedInfo(IRPCModule):
    ## \fn  
    #  \brief 
    #  \param
    def __init__(self, core):
        self.core = core
        self.name="SHARED_INFO"

    ## \fn  main(self)
    #  \brief   Returns the information needed to connect to the shared Webdav 
    def main(self):
        info = {    "IP": self.core.shared.IP, 
                    "port": self.core.shared.port, 
                    "user": self.core.shared.user, 
                    "password": self.core.shared.password
                }
        return info

    def __repr__(self):
        return "%s" % (self.name)

if __name__=="__main__":
    r = RPC_sharedInfo()
    info = r.main()
